SystemOrganization addCategory: #Smutty!
SystemOrganization addCategory: 'Smutty-Tests'!
SystemOrganization addCategory: 'Smutty-Web'!
SystemOrganization addCategory: 'Smutty-Web-Tests'!

WAFileLibrary subclass: #SmuttyLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

WAComponent subclass: #SmuttyWebApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

!SmuttyWebApp methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/16/2015 07:51'!
renderContentOn: html
	html heading with: 'Hola Manola'.! !

TestCase subclass: #DialogNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!DialogNodeTest commentStamp: '<historical>' prior: 0!
A DialogNodeTest is a test class for testing the behavior of DialogNode!

!DialogNodeTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/23/2015 05:42'!
test_01_equality

	| node1 node2 |
	node1 := DialogNode description: 'Hi!!'.
	node2 := DialogNode description: 'Hi!!'.
	self assert: node1 equals: node2.! !

TestCase subclass: #FinishDialogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!FinishDialogTest commentStamp: '<historical>' prior: 0!
A FinishDialogTest is a test class for testing the behavior of FinishDialog!

!FinishDialogTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 10/27/2015 18:14'!
test_01_redefineForGame
	| action |

	action := FinishDialog new.
	action game: 1.
	action redefineForGame: 2.
	self assert: action game = 2.! !

TestCase subclass: #GameStateGraphBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!GameStateGraphBuilderTest commentStamp: '<historical>' prior: 0!
A GameStateGraphBuilderTest is a test class for testing the behavior of GameStateGraphBuilder!

!GameStateGraphBuilderTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/11/2015 06:40'!
test_01_buildingTwoNodes

	| graph initialNode secondNode |
	graph := GameStateGraphBuilder graphFrom: (SJTGameController on: SJTGame twoLocationsExample).
	self assert: graph nodesSize = 2.
	initialNode := graph initialNode.
	secondNode  := (graph nodes detect: [:each | each ~= initialNode]).
	self deny: initialNode = secondNode.
	self assert: (graph transitionsFrom: initialNode) size = 1.
	self assert: (graph transitionsFrom: secondNode) size = 1.! !

!GameStateGraphBuilderTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/11/2015 07:38'!
test_02_buildingFirstTownExample

	| graph firstNode |
	graph := GameStateGraphBuilder graphFrom: (SJTGameController on: SJTGame firstTownExample).
	self assert: graph nodesSize = 11.
	firstNode := graph initialNode.
	self assert: firstNode location neighbours size = 3.
	self assert: (graph transitionsFrom: firstNode) size = 3.! !

!GameStateGraphBuilderTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/22/2015 07:25'!
test_03_buildingSingleLocationWithNPC

	| graph initialNode secondNode |
	graph := GameStateGraphBuilder graphFrom: (SJTGameController on: SJTGame singleLocationWithNPCExample).
	self assert: graph nodesSize = 2.
	initialNode := graph initialNode.
	secondNode  := (graph nodes detect: [:each | each ~= initialNode]).
	self deny: initialNode = secondNode.
	self assert: (graph transitionsFrom: initialNode) size = 1.
	self assert: (graph transitionsFrom: secondNode) size = 1.! !

!GameStateGraphBuilderTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/23/2015 04:59'!
test_04_buildingTwoLocationsWithNPCExample

	| graph initialNode secondNode |
	graph := GameStateGraphBuilder graphFrom: (SJTGameController on: SJTGame twoLocationsWithNPCExample).
	self assert: graph nodesSize = 5.
	initialNode := graph initialNode.
	secondNode  := (graph transitionsFrom: initialNode) first destination.
	self deny: initialNode = secondNode.
	self assert: (graph transitionsFrom: initialNode) size = 1.
	self assert: (graph transitionsFrom: secondNode) size = 2.! !

TestCase subclass: #LocationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!LocationTest commentStamp: '<historical>' prior: 0!
A LocationTest is a test class for testing the behavior of Location!

!LocationTest methodsFor: 'tests' stamp: 'SergioFedi 8/28/2015 23:07'!
test_01_defaultValues

	| newLocation |
	newLocation := Location new.
	self assert: newLocation name = 'New location'.
	self assert: newLocation description = ''.
	self assert: newLocation neighbours isEmpty.
	! !

!LocationTest methodsFor: 'tests' stamp: 'SergioFedi 9/1/2015 16:17'!
test_01_equality

	| location1 location2 |
	location1 := Location new.
	location2 := Location new.
	self assert: location1 = location2.
	! !

TestCase subclass: #NPCTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!NPCTest commentStamp: '<historical>' prior: 0!
A NPCTest is a test class for testing the behavior of NPC!

!NPCTest methodsFor: 'tests' stamp: 'SergioFedi 9/24/2015 06:29'!
test_01_defaultValues

	| npc |
	npc := NPC new.
	self assert: npc dialog isNil.
	self assert: npc name = 'Unnamed'.! !

!NPCTest methodsFor: 'tests' stamp: 'SergioFedi 9/24/2015 06:30'!
test_02_minimalNPC

	| npc |
	npc := NPC lonelyNPC.
	self assert: npc name = 'Lonely NPC'.
	self assert: npc dialog notNil.
	self assert: npc dialog description = 'I''m just a lonely NPC'.
	self assert: npc dialog options isEmpty.! !

!NPCTest methodsFor: 'tests' stamp: 'SergioFedi 9/24/2015 06:31'!
test_03_typicalNPC

	| npc dialogOption1 dialogOption2 |
	npc := NPC lonelyChattyNPC.
	self assert: npc name = 'Lonely NPC'.
	self assert: npc dialog notNil.
	self assert: npc dialog description = 'I''m just a lonely NPC'.
	self assert: npc dialog options size = 2.
	self assert: npc dialog options first description = 'Do you want to talk?'.
	self assert: npc dialog options second description = 'Are you lonely?'.
	dialogOption1 := npc dialog options first.
	self assert: dialogOption1 node description = 'No'.
	self assert: dialogOption1 node options isEmpty.
	dialogOption2 := npc dialog options second.
	self assert: dialogOption2 node description = 'Yes'.
	self assert: dialogOption2 node options isEmpty.
	! !

TestCase subclass: #QuestStateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!QuestStateTest commentStamp: '<historical>' prior: 0!
A QuestStateTest is a test class for testing the behavior of QuestState!

!QuestStateTest methodsFor: 'tests' stamp: 'FedericoFigueredo 6/3/2015 07:41'!
test_01_advancingTheQuest
	| quest questState questAdvancer action |
	
	quest := StoryMap example.
	questState := QuestState on: quest.
	questAdvancer := QuestAdvancer new.
	action := QuestAction description: 'Win!!'.
	
	self assert: questState currentNode = quest nodes first.
	questAdvancer advance: questState with: action.
	self assert: questState currentNode = quest nodes last.! !

TestCase subclass: #SJTGameControllerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!SJTGameControllerTest commentStamp: '<historical>' prior: 0!
A SJTGameControllerTest is a test class for testing the behavior of SJTGameController!

!SJTGameControllerTest methodsFor: 'tests' stamp: 'SergioFedi 9/11/2015 06:35'!
test_01_MovingToOnePlace

	| controller initialLocation finalLocation |
	controller := SJTGameController on: SJTGame twoLocationsExample.
	initialLocation := controller location.
	self assert: controller options size = 1.
	controller choose: controller options first.
	finalLocation := controller location.
	self deny: finalLocation = initialLocation.! !

!SJTGameControllerTest methodsFor: 'tests' stamp: 'SergioFedi 9/11/2015 06:35'!
test_02_MovingBack

	| controller initialLocation finalLocation |
	controller := SJTGameController on: SJTGame twoLocationsExample.
	initialLocation := controller location.
	controller choose: controller options first.
	self assert: controller options size = 1.
	controller choose: controller options first.
	finalLocation := controller location.
	self assert: finalLocation = initialLocation.! !

!SJTGameControllerTest methodsFor: 'tests' stamp: 'SergioFedi 9/11/2015 07:01'!
test_03_OptionsEqualNeighbours

	| controller initialLocation  |
	controller := SJTGameController on: SJTGame firstTownExample.
	initialLocation := controller location.
	self assert: initialLocation neighbours size = 3.
	self assert: controller options size = 3.
! !

!SJTGameControllerTest methodsFor: 'tests' stamp: 'SergioFedi 9/24/2015 06:03'!
test_04_NoOptionsForMoving

	| controller initialLocation  |
	controller := SJTGameController on: SJTGame singleLocationExample.
	initialLocation := controller location.
	self assert: controller options isEmpty.
	self assert: initialLocation notNil.
! !

!SJTGameControllerTest methodsFor: 'tests' stamp: 'SergioFedi 9/24/2015 06:07'!
test_05_CanTalkWithNPC

	| controller initialLocation  |
	controller := SJTGameController on: SJTGame singleLocationWithNPCExample.
	initialLocation := controller location.
	self assert: controller options size = 1.
	self assert: initialLocation notNil.
! !

TestCase subclass: #SJTGameStateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!SJTGameStateTest commentStamp: '<historical>' prior: 0!
A SJTGameStateTest is a test class for testing the behavior of SJTGameState!

!SJTGameStateTest methodsFor: 'tests' stamp: 'SergioFedi 9/23/2015 05:43'!
test_01_equality

	| state1 state2 |
	state1 := SJTGameState location: 1 version: 'pling' dialog: (DialogNode description: 'Hola').
	state2 := SJTGameState location: 1 version: 'pling' dialog: (DialogNode description: 'Hola').
	self assert: state1 = state2.! !

!SJTGameStateTest methodsFor: 'tests' stamp: 'SergioFedi 9/1/2015 16:30'!
test_02_equality2

	| state1 state2 |
	state1 := SJTGame singleLocationExample state.
	state2 := SJTGame twoLocationsExample state.
	self deny: state1 = state2.! !

!SJTGameStateTest methodsFor: 'tests' stamp: 'SergioFedi 9/23/2015 05:51'!
test_03_equality3

	| state1 state2 |
	state1 := SJTGameState location: 1 version: 'pling' dialog: (DialogNode description: 'Hola').
	state2 := SJTGameState location: 1 version: 'pling' dialog: (DialogNode description: 'Chau').
	self deny: state1 = state2.! !

TestCase subclass: #SJTGameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!SJTGameTest commentStamp: '<historical>' prior: 0!
A SJTGameTest is a test class for testing the behavior of SJTGame!

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/2/2015 06:31'!
test_01_creation

	| newSJTGame |
	newSJTGame := SJTGame new.
	self assert: newSJTGame locations isEmpty.
	self assert: newSJTGame playerCharacter isNil.
	self assert: newSJTGame version = 'new'.! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/4/2015 23:03'!
test_02_validityOfNewInstance

	| newSJTGame |
	newSJTGame := SJTGame new.
	self deny: newSJTGame isValid.
	self assert: SJTGame singleLocationExample isValid.
	self assert: SJTGame twoLocationsExample isValid.
	self assert: SJTGame firstTownExample isValid.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/7/2015 07:24'!
test_03_fromMemento

	| anSJTGame memento newSJTGame |
	anSJTGame := SJTGame singleLocationExample.
	memento := anSJTGame state.
	newSJTGame := SJTGame fromMemento: memento.
	self assert: anSJTGame locations size = newSJTGame locations size.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/9/2015 07:26'!
test_04_fromMementoPlayerLocation

	| anSJTGame memento newSJTGame originalLocation |
	anSJTGame := SJTGame twoLocationsExample.
	originalLocation := anSJTGame playerCharacter location.
	anSJTGame optionsForPlayerCharacterMovingToNeighbours first perform.
	memento := anSJTGame state.
	newSJTGame := SJTGame fromMemento: memento.
	self deny: originalLocation = newSJTGame playerCharacter location.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/23/2015 05:26'!
test_05_validityOfFirstTownExample

	| example |
	example := SJTGame firstTownExample.
	self assert: example locations size = 11.
	self assert: example playerCharacter location neighbours size = 3.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/22/2015 07:19'!
test_06_newInstanceAndNPCs

	| newSJTGame |
	newSJTGame := SJTGame new.
	self assert: SJTGame singleLocationExample locations first npcs isEmpty.
	self assert: SJTGame twoLocationsExample locations first npcs isEmpty.
	self assert: SJTGame twoLocationsExample locations second npcs isEmpty.
	self assert: SJTGame singleLocationWithNPCExample locations first npcs notEmpty.
	self deny: SJTGame singleLocationWithNPCExample version = 'singleLocationExample'.
	self assert: SJTGame twoLocationsWithNPCExample locations first npcs isEmpty.
	self assert: SJTGame twoLocationsWithNPCExample locations second npcs notEmpty.
	self assert: SJTGame twoLocationsWithNPCExample version = 'twoLocationsWithNPCExample'.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/16/2015 07:50'!
test_07_optionsForSingleLocationExample

	| game |
	game := SJTGame singleLocationExample.
	self assert: game optionsForPlayerCharacter isEmpty.
	self assert: game optionsForPlayerCharacterMovingToNeighbours isEmpty.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs isEmpty.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/22/2015 07:44'!
test_08_optionsForSingleLocationWithNPCExample

	| game |
	game := SJTGame singleLocationWithNPCExample.
	self assert: game optionsForPlayerCharacter size = 1.
	self assert: game optionsForPlayerCharacterMovingToNeighbours isEmpty.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs size = 1.
	self deny: game playerCharacter isInDialog.
	game optionsForPlayerCharacter first perform.
	self assert: game optionsForPlayerCharacter size = 1.
	self assert: game optionsForPlayerCharacterMovingToNeighbours isEmpty.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs size = 1.
	self assert: game playerCharacter isInDialog.
	game optionsForPlayerCharacter first perform.
	self assert: game optionsForPlayerCharacter size = 1.
	self assert: game optionsForPlayerCharacterMovingToNeighbours isEmpty.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs size = 1.
	self deny: game playerCharacter isInDialog.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/22/2015 07:41'!
test_09_optionsForTwoLocationsWithNPCExample

	| game |
	game := SJTGame twoLocationsWithNPCExample.
	self assert: game optionsForPlayerCharacter size = 1.
	self assert: game optionsForPlayerCharacterMovingToNeighbours size = 1.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs isEmpty.
	game optionsForPlayerCharacter first perform.
	self assert: game optionsForPlayerCharacter size = 2.
	self assert: game optionsForPlayerCharacterMovingToNeighbours size = 1.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs size = 1.
	game optionsForPlayerCharacterInteractingWithNPCs first perform.
	self assert: game optionsForPlayerCharacter size = 2.
	self assert: game optionsForPlayerCharacterMovingToNeighbours isEmpty.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs size = 2.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/23/2015 06:56'!
test_10_fromMementoInDialog

	| originalSJTGame memento newSJTGame |
	originalSJTGame := SJTGame singleLocationWithNPCExample.
	originalSJTGame optionsForPlayerCharacter first perform.
	memento := originalSJTGame state.
	newSJTGame := SJTGame fromMemento: memento.
	self assert: originalSJTGame locations size = newSJTGame locations size.
	self assert: originalSJTGame playerCharacter isInDialog.
	self assert: newSJTGame playerCharacter isInDialog.

! !

TestCase subclass: #SJTRendererTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web-Tests'!

!SJTRendererTest commentStamp: 'SergioFedi 8/18/2015 07:45' prior: 0!
I test the rendering of the SJT game.!

!SJTRendererTest methodsFor: 'assertions' stamp: 'SergioFedi 8/26/2015 07:22'!
assertFileReference: aFileReference containsLocationName: locationName andDescription: description

	| contents |
	contents := aFileReference contents.
	self assert: (contents includesSubstring: locationName).
	self assert: (contents includesSubstring: description).
! !

!SJTRendererTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 8/27/2015 07:58'!
test_01_SingleNodeRendering

	| renderer filesystem |
	filesystem := FileSystem memory.
	renderer := SJTRenderer new.
	renderer filesystem: filesystem.
	renderer outputDirectory: 'SmuttyTest'.
	renderer htmlName: 'testGame'.
	renderer graph: (GameStateGraph on: (SJTGameController on: SJTGame singleLocationExample)).
	renderer render.
	self assert: (filesystem exists: 'SmuttyTest:testGame.html').
	self assert: (filesystem exists: 'SmuttyTest:testGame_node_1.html').
	self deny: (filesystem exists: 'SmuttyTest:testGame_node_2.html').
	self 
		assertFileReference: (filesystem referenceTo: 'SmuttyTest:testGame_node_1.html') 
		containsLocationName: 'Town Gate Entry' 
		andDescription: 'You stand at a surprisingly solid looking entryway'.! !

!SJTRendererTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 8/27/2015 08:00'!
test_02_TwoNodeRendering

	| renderer filesystem |
	filesystem := FileSystem memory.
	renderer := SJTRenderer new.
	renderer filesystem: filesystem.
	renderer outputDirectory: 'SmuttyTest'.
	renderer htmlName: 'testGame'.
	renderer graph: (GameStateGraph on: (SJTGameController on: SJTGame twoLocationsExample)).
	renderer render.
	self assert: (filesystem exists: 'SmuttyTest:testGame.html').
	self assert: (filesystem exists: 'SmuttyTest:testGame_node_1.html').
	self assert: (filesystem exists: 'SmuttyTest:testGame_node_2.html').
	self deny: (filesystem exists: 'SmuttyTest:testGame_node_3.html').
	self 
		assertFileReference: (filesystem referenceTo: 'SmuttyTest:testGame_node_1.html') 
		containsLocationName: 'Town Gate Entry' 
		andDescription: 'You stand at a surprisingly solid looking entryway'.! !

!SJTRendererTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/8/2015 07:14'!
test_03_FirstTownRendering

	| renderer filesystem |
	filesystem := FileSystem memory.
	renderer := SJTRenderer new.
	renderer filesystem: filesystem.
	renderer outputDirectory: 'SmuttyTest'.
	renderer htmlName: 'testGame'.
	renderer graph: (GameStateGraph on: (SJTGameController on: SJTGame firstTownExample)).
	renderer render.
	self assert: (filesystem exists: 'SmuttyTest:testGame.html').
	self assert: (filesystem exists: 'SmuttyTest:testGame_node_1.html').
	self assert: (filesystem exists: 'SmuttyTest:testGame_node_11.html').
	self deny: (filesystem exists: 'SmuttyTest:testGame_node_12.html').
	self 
		assertFileReference: (filesystem referenceTo: 'SmuttyTest:testGame_node_1.html') 
		containsLocationName: 'Town Gate Entry' 
		andDescription: 'You stand at a surprisingly solid looking entryway'.! !

!SJTRendererTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/24/2015 06:25'!
test_04_SingleNodeWithNPCRendering

	| renderer filesystem |
	filesystem := FileSystem memory.
	renderer := SJTRenderer new.
	renderer filesystem: filesystem.
	renderer outputDirectory: 'SmuttyTest'.
	renderer htmlName: 'testGame'.
	renderer graph: (GameStateGraph on: (SJTGameController on: SJTGame singleLocationWithNPCExample)).
	renderer render.
	self assert: (filesystem exists: 'SmuttyTest:testGame.html').
	self assert: (filesystem exists: 'SmuttyTest:testGame_node_2.html').
	self deny: (filesystem exists: 'SmuttyTest:testGame_node_3.html').
	self 
		assertFileReference: (filesystem referenceTo: 'SmuttyTest:testGame_node_1.html') 
		containsLocationName: 'Town Gate Entry' 
		andDescription: 'You stand at a surprisingly solid looking entryway'.! !

!SJTRendererTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/24/2015 06:41'!
test_05_TwoLocationsWithNPCRendering

	| renderer filesystem |
	filesystem := FileSystem memory.
	renderer := SJTRenderer new.
	renderer filesystem: filesystem.
	renderer outputDirectory: 'SmuttyTest'.
	renderer htmlName: 'testGame'.
	renderer graph: (GameStateGraph on: (SJTGameController on: SJTGame twoLocationsWithNPCExample)).
	renderer render.
	self assert: (filesystem exists: 'SmuttyTest:testGame.html').
	self assert: (filesystem exists: 'SmuttyTest:testGame_node_5.html').
	self deny: (filesystem exists: 'SmuttyTest:testGame_node_6.html').
	self 
		assertFileReference: (filesystem referenceTo: 'SmuttyTest:testGame_node_1.html') 
		containsLocationName: 'Town Gate Entry' 
		andDescription: 'You stand at a surprisingly solid looking entryway'.! !

TestCase subclass: #StoryMapHtmlRendererTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web-Tests'!

!StoryMapHtmlRendererTest commentStamp: 'SergioFedi 6/5/2015 23:34' prior: 0!
A StoryMapHtmlRendererTest is a test class for testing the behavior of StoryMapHtmlRenderer!

!StoryMapHtmlRendererTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 6/6/2015 00:28'!
test_01_basicUsage

	| renderer filesystem |
	filesystem := FileSystem memory.
	renderer := StoryMapHtmlRenderer new.
	renderer filesystem: filesystem.
	renderer outputDirectory: 'SmuttyTest'.
	renderer htmlName: 'testStory'.
	renderer storyMap: StoryMap example.
	renderer render.
	self assert: (filesystem exists: 'SmuttyTest:testStory.html').
	self assert: (filesystem exists: 'SmuttyTest:testStory_node_1.html').
	self assert: (filesystem exists: 'SmuttyTest:testStory_node_2.html').


! !

!StoryMapHtmlRendererTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 6/6/2015 00:30'!
test_02_defaultFilesystem

	| renderer |
	renderer := StoryMapHtmlRenderer new.
	self assert: (renderer filesystem class = FileReference).
! !

TestCase subclass: #StoryMapMarkdownRendererTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web-Tests'!

!StoryMapMarkdownRendererTest commentStamp: '<historical>' prior: 0!
A StoryMapMarkdownRendererTest is a test class for testing the behavior of StoryMapMarkdownRenderer!

!StoryMapMarkdownRendererTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/19/2015 07:43'!
test_01_basicUsage
| aStoryMap markdownText renderer |
aStoryMap := StoryMap example.
renderer := StoryMapMarkdownRenderer on: aStoryMap.
markdownText := renderer render.

self assert: markdownText notNil.
self assert: markdownText equals: 
'# Name1
Welcome to the game. It''s super hot. Wear mittens!!

[Win!!](Name2)

# Name2
You''ve won the game. You should be proud. We hope you enjoyed the lack of any erotic content.
'.! !

TestCase subclass: #StoryMapTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!StoryMapTest commentStamp: '<historical>' prior: 0!
A StoryMapTest is a test class for testing the behavior of StoryMap!

!StoryMapTest methodsFor: 'tests' stamp: 'SergioFedi 6/5/2015 20:59'!
test_01_example

	| story |
	story := StoryMap example.
	self assert: story beginning notNil.
	self assert: story nodes notEmpty.
	self assert: story transitions notEmpty.! !

TestCase subclass: #StoryNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!StoryNodeTest commentStamp: '<historical>' prior: 0!
A StoryNodeTest is a test class for testing the behavior of StoryNode!

!StoryNodeTest methodsFor: 'tests' stamp: 'SergioFedi 6/6/2015 00:17'!
test_01_creation

	| node |
	node := StoryNode new.
	self assert: node text isNil.
	node text: 'test'.
	self assert: node text = 'test'.! !

!StoryNodeTest methodsFor: 'tests' stamp: 'SergioFedi 6/18/2015 06:42'!
test_02_textParsing

	| node |
	node := StoryNode new.
	self assert: node text isNil.
	self assert: node paragraphs isNil.
	node text: 'Paragraph 1 should be followed by two line breaks.

Paragraph 2 is the following text'.

	self assert: node paragraphs size = 2.
	self assert: node paragraphs first = 'Paragraph 1 should be followed by two line breaks.'.
	self assert: node paragraphs second = 'Paragraph 2 is the following text'.! !

TestCase subclass: #StoryTransitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!StoryTransitionTest commentStamp: '<historical>' prior: 0!
A StoryTransitionTest is a test class for testing the behavior of StoryTransition!

!StoryTransitionTest methodsFor: 'tests' stamp: 'FedericoFigueredo 6/3/2015 08:00'!
test_01_actionDescription
	| transition placeholderOrigin placeholderDestination |
	
	placeholderOrigin := nil.
	placeholderDestination := nil.
	transition := StoryTransition origin: placeholderOrigin destination: placeholderDestination actionDescription: 'Win!!'. 
	
	self assert: (transition actionDescription = 'Win!!').! !

WASession subclass: #SmuttySession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

Object subclass: #DialogNode
	instanceVariableNames: 'options description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!DialogNode class methodsFor: 'instance creation' stamp: 'SergioFedi 9/15/2015 07:51'!
description: aString

	^self new
		description: aString.! !

!DialogNode methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/23/2015 05:56'!
= aDialogNode

	aDialogNode ifNil: [ ^false ].
	^self description = aDialogNode description.! !

!DialogNode methodsFor: 'public' stamp: 'SergioFedi 9/15/2015 08:04'!
addOption: aDialogOption

	self options add: aDialogOption.! !

!DialogNode methodsFor: 'accessing' stamp: 'SergioFedi 9/15/2015 07:53'!
description
	^ description! !

!DialogNode methodsFor: 'accessing' stamp: 'SergioFedi 9/15/2015 07:52'!
description: aString

	description := aString! !

!DialogNode methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/23/2015 05:38'!
hash

	^self description hash.! !

!DialogNode methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/15/2015 07:52'!
initialize

	options := OrderedCollection new.! !

!DialogNode methodsFor: 'accesing' stamp: 'SergioFedi 9/15/2015 07:53'!
options
	^ options! !

!DialogNode methodsFor: 'public' stamp: 'SergioFedi 9/24/2015 05:40'!
yourselfAndAllSubnodes

	| answer |
	answer := OrderedCollection with: self.
	self options
		inject: answer
		into: [ :suboptions :option |
			suboptions addAll: option node yourselfAndAllSubnodes.
			suboptions.].
	^answer.! !

Object subclass: #DialogOption
	instanceVariableNames: 'description node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!DialogOption class methodsFor: 'instance creation' stamp: 'SergioFedi 9/15/2015 08:04'!
description: aString node: aDialogNode

	^self new
		description: aString;
		node: aDialogNode.! !

!DialogOption methodsFor: 'accessing' stamp: 'SergioFedi 9/15/2015 08:03'!
description
	^ description! !

!DialogOption methodsFor: 'accessing' stamp: 'SergioFedi 9/15/2015 08:03'!
description: anObject
	description := anObject! !

!DialogOption methodsFor: 'accessing' stamp: 'SergioFedi 9/15/2015 08:03'!
node
	^ node! !

!DialogOption methodsFor: 'accessing' stamp: 'SergioFedi 9/15/2015 08:03'!
node: anObject
	node := anObject! !

Object subclass: #GameStateGraph
	instanceVariableNames: 'initialNode nodes connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!GameStateGraph commentStamp: 'SergioFedi 8/19/2015 07:21' prior: 0!
I am a graph in which each node is a game state and each edge is an option I can choose that makes me transition from one state to another.!

!GameStateGraph class methodsFor: 'instance creation' stamp: 'SergioFedi 8/31/2015 09:53'!
nodes: aCollection initialNode: initialNode

	^self new initializeWithNodes: aCollection initialNode: initialNode.! !

!GameStateGraph class methodsFor: 'instance creation' stamp: 'SergioFedi 8/20/2015 08:48'!
on: aSJTGameController

	^GameStateGraphBuilder graphFrom: aSJTGameController.! !

!GameStateGraph methodsFor: 'public' stamp: 'SergioFedi 9/2/2015 08:01'!
addNode: aNode

	nodes add: aNode.
! !

!GameStateGraph methodsFor: 'public' stamp: 'SergioFedi 9/2/2015 07:59'!
connect: aSJTGameState to: anotherSJTGameState with: anAction

	(nodes includes: aSJTGameState) ifFalse: [ self error: 'Origin node not contained in graph' ].
	(nodes includes: anotherSJTGameState) ifFalse: [ self error: 'Destination node not contained in graph' ].
	^connections add: (SJTGameStateTransition origin: aSJTGameState destination: anotherSJTGameState action: anAction).! !

!GameStateGraph methodsFor: 'public' stamp: 'SergioFedi 9/8/2015 06:26'!
includesNode: aSJTGameState
 
	^self nodes includes: aSJTGameState.! !

!GameStateGraph methodsFor: 'accessors' stamp: 'SergioFedi 8/24/2015 08:16'!
initialNode
	^ initialNode! !

!GameStateGraph methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/1/2015 16:02'!
initializeWithNodes: aCollection initialNode: aSJTGameState

	initialNode := aSJTGameState.
	nodes := aCollection asSet.
	(nodes includes: aSJTGameState) ifFalse: [ self error: 'Initial node is not part of the graph' ].
	connections := OrderedCollection new.
! !

!GameStateGraph methodsFor: 'public' stamp: 'SergioFedi 8/31/2015 10:02'!
nodes
	^ nodes! !

!GameStateGraph methodsFor: 'public' stamp: 'SergioFedi 8/31/2015 09:58'!
nodesSize

	^nodes size.! !

!GameStateGraph methodsFor: 'public' stamp: 'SergioFedi 9/1/2015 16:06'!
transitionsFrom: aGraphNode

	^connections select: [:transition | transition origin = aGraphNode].
	! !

Object subclass: #GameStateGraphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!GameStateGraphBuilder commentStamp: 'SergioFedi 9/7/2015 07:05' prior: 0!
I construct a GameStateGraph from aSJTGame  using a SJTGameController as the interface with which Iinteract with the game.!

!GameStateGraphBuilder class methodsFor: 'factory' stamp: 'SergioFedi 9/22/2015 07:09'!
graphFrom: aSJTGameController

	| graph initialNode actions sizeLimit controllerClass |
	controllerClass := aSJTGameController class.
	sizeLimit := 100.
	initialNode := aSJTGameController state.
	actions := aSJTGameController options.
	graph := GameStateGraph nodes: (Set with: initialNode) initialNode: initialNode.
	[actions isEmpty or: [actions size > sizeLimit]] whileFalse: [
		| currentAction currentState nextState controller |
		currentAction := actions removeFirst.
		currentState := currentAction game state.
		currentAction redefineForGame: currentState newGame.
		controller := controllerClass on: currentAction game.
		controller choose: currentAction.
		nextState := controller state.
		currentAction game: nil.
		(graph includesNode: nextState) ifFalse: [
			graph addNode: nextState.
			actions addAll: (controllerClass on: nextState newGame) options.
		].
		graph connect: currentState to: nextState with: currentAction.
	].
	(actions size > sizeLimit) ifTrue: [ self error: 'Graph larger than expected' ].
	^graph.! !

Object subclass: #GraphRenderer
	instanceVariableNames: 'graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

!GraphRenderer commentStamp: 'SergioFedi 8/24/2015 07:06' prior: 0!
I render a graph.
!

GraphRenderer subclass: #GraphHtmlRenderer
	instanceVariableNames: 'filesystem outputDirectory htmlName enumeratedNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

!GraphHtmlRenderer commentStamp: 'SergioFedi 8/24/2015 07:06' prior: 0!
I render a graph in HTML!

!GraphHtmlRenderer methodsFor: 'public' stamp: 'SergioFedi 9/9/2015 08:27'!
enumerateNodes

	| nodes firstNode |
	enumeratedNodes := Dictionary new.
	nodes := LinkedList newFrom: self graph nodes.
	firstNode := self firstNodeFrom: self graph.
	nodes remove: firstNode.
	nodes addFirst: firstNode.
	nodes
		with: (1 to: self graph nodesSize)
		do: [:node :index |
			enumeratedNodes at: node put: index.
		].
! !

!GraphHtmlRenderer methodsFor: 'accessors' stamp: 'SergioFedi 8/24/2015 07:09'!
filesystem
	filesystem isNil ifTrue: [ filesystem := FileSystem workingDirectory ].
	^ filesystem! !

!GraphHtmlRenderer methodsFor: 'accessors' stamp: 'SergioFedi 8/24/2015 07:09'!
filesystem: aFileSystem 
	filesystem := aFileSystem.! !

!GraphHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 9/9/2015 07:44'!
firstNodeFrom: aGraph

	self subclassResponsibility.! !

!GraphHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 8/25/2015 08:19'!
htmlFileContentsForNode: aGraphNode withTransitions: transitions

	^WAHtmlCanvas builder 
	fullDocument: false;
	render: [ :html |
		self renderNode: aGraphNode from: self graph on: html]! !

!GraphHtmlRenderer methodsFor: 'accessors' stamp: 'SergioFedi 8/24/2015 07:13'!
htmlName: aString 
	htmlName := aString .! !

!GraphHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 8/24/2015 07:41'!
mainHtmlFileContents

	| doc ctx root html |
	^String streamContents: [ :stream |
	    doc := WAHtmlDocument on: stream.
	    ctx := WARenderContext new document: doc.
	    root := WAHtmlRoot new.
		 root setContext: ctx.
	    self rootBlock value: root.
	    root writeHeadOn: doc.
	    html := WAHtmlCanvas new initializeWithContext: ctx.
	    self renderBlock value: html.
	    root writeFootOn: doc ].
! !

!GraphHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 8/24/2015 07:47'!
mainStoryDivId
	^ 'mainStoryNode'! !

!GraphHtmlRenderer methodsFor: 'accessing' stamp: 'SergioFedi 8/24/2015 07:13'!
outputDirectory
	^ outputDirectory! !

!GraphHtmlRenderer methodsFor: 'accessors' stamp: 'SergioFedi 8/24/2015 07:12'!
outputDirectory: aString 
	outputDirectory := aString.! !

!GraphHtmlRenderer methodsFor: 'public' stamp: 'SergioFedi 8/24/2015 07:22'!
render

	filesystem ensureCreateDirectory: self outputDirectory.
	self enumerateNodes.
	self renderMainHtmlFile.
	self renderStoryNodes.! !

!GraphHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 8/24/2015 07:48'!
renderBlock
	^ [ :html | 
	html div 
		class: 'container';
		with:
		[	html heading level1 with: 'Story Map'.
			html div
				id: self mainStoryDivId;
				class: 'storyNode';
				with: [ :html2 | self renderFirstNodeFrom: self graph on: html2 ].
			html script with: 'function onLoad(){
				installNavigationFunctionality();
			};'.
		]
	].
! !

!GraphHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 9/9/2015 07:41'!
renderFirstNodeFrom: aGraph on: html

	self renderNode: (self firstNodeFrom: aGraph) from: aGraph on: html! !

!GraphHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 8/24/2015 07:24'!
renderMainHtmlFile

	| htmlFile |
	htmlFile := filesystem writeStreamOn: self outputDirectory, filesystem separator asString, htmlName, '.html'.
	htmlFile nextPutAll: self mainHtmlFileContents.
	htmlFile close.! !

!GraphHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 8/24/2015 07:47'!
renderScriptsOn: root

	root script
		url: 'lib/jquery-1.11.2.min.js'.
	root script
		url: 'lib/smuttyFunctions.js'.
	"root addScript: 'function onLoad(){
		installNavigationFunctionality();
	};'."
! !

!GraphHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 8/25/2015 08:16'!
renderStoryNodes

	enumeratedNodes associationsDo: 
		[:association |
			| htmlFile node index |
			node := association key.
			index := association value.
			
			htmlFile := filesystem writeStreamOn:
				self outputDirectory, 
				filesystem separator asString, 
				htmlName, 
				('_node_{1}.html' format: index asOrderedCollection).
			htmlFile nextPutAll: (self htmlFileContentsForNode: node withTransitions: (self graph transitionsFrom: node)).
			htmlFile close.
		].! !

!GraphHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 8/24/2015 07:46'!
rootBlock
	^ [ :root | 
	root
		title: self title;
		beHtml5.
	root stylesheet url: 'css/testStory.css'.
	root meta charset: 'utf-8'.
	self renderScriptsOn: root ]! !

GraphHtmlRenderer subclass: #SJTRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

!SJTRenderer commentStamp: 'SergioFedi 9/11/2015 06:19' prior: 0!
I know how to render an interface over an SJTGame.!

!SJTRenderer methodsFor: 'private' stamp: 'SergioFedi 9/9/2015 07:39'!
firstNodeFrom: aGameStateGraph
	^ aGameStateGraph initialNode! !

!SJTRenderer methodsFor: 'private' stamp: 'SergioFedi 8/31/2015 10:32'!
renderNode: aGameStateNode from: aGameStateGraph on: html 
	
	| transitions interface |
	interface := SJTGameController on: (aGameStateNode newGame).
	transitions := interface options.
	html div
		class: 'locationName';
		with: [
			html paragraph with: (interface locationName).
		].
	html div
		class: 'locationDescription';
		with: [
			html paragraph with: (interface locationDescription).
		].
	html div
		class: 'options';
		with: [
			(aGameStateGraph transitionsFrom: aGameStateNode) do: [:transition | 
				| anchor  htmlNodeName |
				anchor := html anchor.
				htmlNodeName := htmlName, '_node_', (enumeratedNodes at: transition destination) asString, '.html'.
				anchor class: 'action'.
				anchor attributes at: 'htmlReference' put: htmlNodeName.
				anchor with: transition action description.
			]
		].! !

!SJTRenderer methodsFor: 'private' stamp: 'SergioFedi 8/24/2015 07:47'!
title
	^ 'SJT (Locations) Render'! !

SJTRenderer subclass: #SJTRendererDraft01
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

!SJTRendererDraft01 commentStamp: 'SergioFedi 9/11/2015 06:32' prior: 0!
I render the first draft of the SJTGame interface.

Its mostly functional, no graphics.
The options are buttons.

!

SJTRenderer subclass: #SJTRendererDraft02
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

!SJTRendererDraft02 commentStamp: 'SergioFedi 9/11/2015 06:31' prior: 0!
I render the second draft of the SJTGame interface.

Its mostly functional, no graphics.
It differentiates between movement options and interacting options.
The options are a line of text instead of buttons.
!

!SJTRendererDraft02 methodsFor: 'private' stamp: 'SergioFedi 9/29/2015 07:40'!
actionSubtypeForTransition: aGameTransition

	| answer |
	(aGameTransition action class = FinishDialog) ifTrue: [answer := 'ender'].
	(aGameTransition action class = InteractWithNPC) ifTrue: [answer := 'opener'].
	^answer.
	.! !

!SJTRendererDraft02 methodsFor: 'private' stamp: 'SergioFedi 9/29/2015 07:41'!
actionTypeForTransition: aGameTransition

	| answer |
	(aGameTransition action class = MoveAction) ifTrue: [answer := 'movement'].
	(aGameTransition action class = FinishDialog) ifTrue: [answer := 'interaction'].
	(aGameTransition action class = InteractWithNPC) ifTrue: [answer := 'interaction'].
	(aGameTransition action class = ChooseDialogOption) ifTrue: [answer := 'interaction'].
	answer isNil ifTrue: [
		"Error: we don't have a mapping between the type of transition and the actionType HTML attribute of the list item"
		self halt.].
	^answer.
	! !

!SJTRendererDraft02 methodsFor: 'private' stamp: 'SergioFedi 9/29/2015 07:32'!
addActionTypesTo: aTag forTransition: aGameTransition

	| subType |
	aTag attributeAt: 'actionType' put: (self actionTypeForTransition: aGameTransition).
	subType := (self actionSubtypeForTransition: aGameTransition).
	subType notNil ifTrue: [
		aTag attributeAt: 'actionSubtype' put: subType.
	].! !

!SJTRendererDraft02 methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/29/2015 06:38'!
renderBlock
	^ [ :html | 
	html div 
		class: 'container';
		with:
		[	
			html div
				id: self mainStoryDivId;
				class: 'storyNode';
				with: [ :html2 | self renderFirstNodeFrom: self graph on: html2 ].
			html script with: 'function onLoad(){
				installNavigationFunctionality();
			};'.
		]
	].! !

!SJTRendererDraft02 methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 9/10/2015 07:21'!
renderMainHtmlFile! !

!SJTRendererDraft02 methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/29/2015 07:27'!
renderNode: aGameStateNode from: aGameStateGraph on: html 
	
	| transitions interface |
	interface := SJTGameController on: (aGameStateNode newGame).
	transitions := interface options.
	html heading level2
		class: 'locationName';
		with: [
			html text: interface locationName.
		].
	html paragraph
		class: 'locationDescription';
		with: [
			html text: (interface locationDescription).
		].
	html unorderedList 
		class: 'optionList locationActions';
		with: [
			(aGameStateGraph transitionsFrom: aGameStateNode) do: [:transition | 
				| htmlNodeName listItem |
				
				htmlNodeName := htmlName, '_node_', (enumeratedNodes at: transition destination) asString, '.html'.
				listItem := html listItem.
				self addActionTypesTo: listItem forTransition: transition.
				listItem
					attributeAt: 'htmlReference' put: htmlNodeName;
					with: [ 
						html paragraph 
							with: transition action description].
			]
		].! !

!SJTRendererDraft02 methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/29/2015 06:48'!
title
	^ 'SJT (Locations & NPCs) Render'! !

GraphHtmlRenderer subclass: #StoryMapHtmlRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

!StoryMapHtmlRenderer commentStamp: 'SergioFedi 6/5/2015 23:33' prior: 0!
I render a StoryMap in several files.
Among these files there will be a main html file which you can browse statically to navigate the StoryMap.!

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 9/9/2015 07:39'!
firstNodeFrom: aStoryMap
	^ aStoryMap beginning! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 8/25/2015 08:00'!
renderNode: aStoryNode from: aStoryMap on: html 
	
	| transitions |
	transitions := aStoryMap transitionsFrom: aStoryNode.
	html div
		class: 'nodeText';
		with: [
			aStoryNode paragraphs do: [:paragraph |
				html paragraph with: paragraph.
			]
		].
	html div
		class: 'actions';
		with: [
			transitions do: [:transition | 
				| anchor  htmlNodeName |
				anchor := html anchor.
				htmlNodeName := htmlName, '_node_', (enumeratedNodes at: transition destination) asString, '.html'.
				anchor class: 'action'.
				anchor attributes at: 'htmlReference' put: htmlNodeName.
				anchor with: transition actionDescription.
			]
		].! !

!StoryMapHtmlRenderer methodsFor: 'accessing' stamp: 'SergioFedi 8/18/2015 07:28'!
storyMap
	^self graph! !

!StoryMapHtmlRenderer methodsFor: 'accessors' stamp: 'SergioFedi 8/18/2015 07:25'!
storyMap: aStoryMap 
	self graph: aStoryMap.! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 8/24/2015 07:46'!
title
	^ 'Story Map Render'! !

!GraphRenderer methodsFor: 'accessing' stamp: 'SergioFedi 8/18/2015 07:24'!
graph
	^ graph! !

!GraphRenderer methodsFor: 'accessing' stamp: 'SergioFedi 8/18/2015 07:24'!
graph: anObject
	graph := anObject! !

!GraphRenderer methodsFor: 'as yet unclassified' stamp: 'SergioFedi 8/18/2015 07:22'!
render

	self subclassResponsibility.! !

GraphRenderer subclass: #StoryMapMarkdownRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

!StoryMapMarkdownRenderer commentStamp: 'SergioFedi 8/18/2015 07:19' prior: 0!
I render a StoryMap in a single file.
This is a render in markdown syntax.!

!StoryMapMarkdownRenderer class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/18/2015 08:06'!
on: aStoryMap 
	^ self new storyMap: aStoryMap.! !

!StoryMapMarkdownRenderer methodsFor: 'public' stamp: 'SergioFedi 8/18/2015 07:26'!
render
	| stream nodes |
	stream := WriteStream on: String new.
	nodes := self storyMap nodes.
	
	nodes do: 
		[ :node | stream 
		nextPutAll: '# Name', (nodes indexOf: node) asString;
		cr;
		nextPutAll: node text;
		cr.
		(self storyMap transitionsFrom: node) do: [ :transition | stream 
			cr;
			nextPut: $[; 
			nextPutAll: transition actionDescription;
			nextPut: $];
			nextPut: $(;
			nextPutAll: 'Name', (nodes indexOf: transition destination) asString;
			"Después hacemos algo tipo | nextPutAll: transition destination name;"
			nextPut: $);
			yourself.]
		]
		separatedBy: [ stream cr; cr ].
		
	^ stream contents.! !

!StoryMapMarkdownRenderer methodsFor: 'accessing' stamp: 'SergioFedi 8/18/2015 07:28'!
storyMap
	^self graph.! !

!StoryMapMarkdownRenderer methodsFor: 'accessors' stamp: 'SergioFedi 8/18/2015 07:25'!
storyMap: aStoryMap

	self graph: aStoryMap.! !

Object subclass: #Location
	instanceVariableNames: 'name description neighbours npcs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!Location commentStamp: 'SergioFedi 8/28/2015 22:38' prior: 0!
I model the place a PlayerCharacter or an NPC can be.

I have a name and a description.

I also know the neighbours I have.
!

!Location class methodsFor: 'instance creation' stamp: 'SergioFedi 8/20/2015 07:42'!
named: aString description: aString2

	^self new
		name: aString;
		description: aString2;
		yourself.! !

!Location methodsFor: 'comparing' stamp: 'SergioFedi 9/1/2015 16:19'!
= anObject

	^((self name = anObject name)
	and: [self description = anObject description])
	and: [ self neighbours size = self neighbours size ]! !

!Location methodsFor: 'public' stamp: 'SergioFedi 9/15/2015 06:44'!
addNPC: aNPC

	self npcs add: aNPC.! !

!Location methodsFor: 'public' stamp: 'SergioFedi 8/28/2015 23:14'!
addNeighbour: aLocation 
	self neighbours add: aLocation.! !

!Location methodsFor: 'accessors' stamp: 'SergioFedi 8/20/2015 09:11'!
description
	^ description! !

!Location methodsFor: 'accessors' stamp: 'SergioFedi 8/20/2015 07:43'!
description: aString

	description := aString.! !

!Location methodsFor: 'comparing' stamp: 'SergioFedi 9/1/2015 16:25'!
hash

	^(self name hash bitXor: self description hash) bitXor: self neighbours size! !

!Location methodsFor: 'initialization' stamp: 'SergioFedi 9/15/2015 06:42'!
initialize

	super initialize.
	self name: 'New location'.
	self description: ''.
	neighbours := OrderedCollection new.
	npcs := OrderedCollection new.
! !

!Location methodsFor: 'accessors' stamp: 'SergioFedi 8/20/2015 09:10'!
name

	^name.! !

!Location methodsFor: 'accessors' stamp: 'SergioFedi 8/20/2015 07:42'!
name: aString

	name := aString.! !

!Location methodsFor: 'accessors' stamp: 'SergioFedi 8/28/2015 23:12'!
neighbours
	^ neighbours! !

!Location methodsFor: 'accessing' stamp: 'SergioFedi 9/15/2015 06:42'!
npcs

	^npcs.! !

!Location methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/8/2015 06:55'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self name printOn: aStream.
	aStream nextPut: $).
! !

Object subclass: #NPC
	instanceVariableNames: 'dialog name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!NPC class methodsFor: 'instance-creation' stamp: 'SergioFedi 9/24/2015 06:33'!
lonelyChattyNPC

	| npc |
	npc := self new.
	npc name: 'Lonely NPC'.
	npc dialog: (DialogNode description: 'I''m just a lonely NPC').
	npc dialog addOption: (DialogOption description: 'Do you want to talk?' node: (DialogNode description: 'No')).
	npc dialog addOption: (DialogOption description: 'Are you lonely?' node: (DialogNode description: 'Yes')).
	^npc.! !

!NPC class methodsFor: 'instance creation' stamp: 'SergioFedi 9/24/2015 06:33'!
lonelyNPC

	| npc |
	npc := self new.
	npc name: 'Lonely NPC'.
	npc dialog: (DialogNode description: 'I''m just a lonely NPC').
	^npc.! !

!NPC methodsFor: 'accessing' stamp: 'SergioFedi 9/15/2015 07:36'!
dialog
	^ dialog! !

!NPC methodsFor: 'accessing' stamp: 'SergioFedi 9/15/2015 07:53'!
dialog: aDialogNode

	dialog := aDialogNode! !

!NPC methodsFor: 'public' stamp: 'SergioFedi 9/23/2015 07:18'!
dialogNodes

	| nodes |
	nodes := OrderedCollection new.
	self dialog notNil ifTrue: [
		nodes addAll: self dialog yourselfAndAllSubnodes.
	].
	^nodes.! !

!NPC methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/24/2015 06:32'!
initialize

	super initialize.
	self name: 'Unnamed'.! !

!NPC methodsFor: 'accessing' stamp: 'SergioFedi 9/24/2015 06:33'!
name
	^ name! !

!NPC methodsFor: 'accessing' stamp: 'SergioFedi 9/24/2015 06:32'!
name: anObject
	name := anObject! !

Object subclass: #PlayerCharacter
	instanceVariableNames: 'location currentDialog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!PlayerCharacter class methodsFor: 'instance creation' stamp: 'SergioFedi 8/20/2015 07:46'!
location: aLocation

	^self new
		location: aLocation;
		yourself.! !

!PlayerCharacter methodsFor: 'accessing' stamp: 'SergioFedi 9/22/2015 07:45'!
currentDialog
	^ currentDialog! !

!PlayerCharacter methodsFor: 'accessing' stamp: 'SergioFedi 9/22/2015 07:26'!
currentDialog: aDialogNode

	currentDialog := aDialogNode.! !

!PlayerCharacter methodsFor: 'querying' stamp: 'SergioFedi 9/22/2015 07:45'!
isInDialog

	^self currentDialog notNil.! !

!PlayerCharacter methodsFor: 'accessors' stamp: 'SergioFedi 8/20/2015 09:07'!
location
	^ location! !

!PlayerCharacter methodsFor: 'accessors' stamp: 'SergioFedi 8/20/2015 07:46'!
location: aLocation

	location := aLocation.! !

Object subclass: #QuestAction
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!QuestAction commentStamp: 'SergioFedi 6/5/2015 20:45' prior: 0!
I model an action that can be taken in the context of a quest or that is relevant to a quest (or quests, in general).!

!QuestAction class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/3/2015 07:43'!
description: aString 
	^ self new description: aString.! !

!QuestAction methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:48'!
description
	^ description.! !

!QuestAction methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 07:43'!
description: aString 
	description := aString.! !

Object subclass: #QuestAdvancer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!QuestAdvancer commentStamp: 'SergioFedi 6/5/2015 21:00' prior: 0!
This class does not model anything, it's just here for research purposes.!

!QuestAdvancer methodsFor: 'public' stamp: 'FedericoFigueredo 6/3/2015 08:04'!
advance: aQuestState with: anAction 
	| relevantTransitions advancingTransitions advancingTransition |
	
	relevantTransitions := aQuestState quest transitionsFrom: aQuestState currentNode.
	advancingTransitions := relevantTransitions select: [ :each | each actionDescription = anAction description ].
	advancingTransition := advancingTransitions first.
	
	aQuestState currentNode: advancingTransition destination.! !

Object subclass: #QuestState
	instanceVariableNames: 'quest currentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!QuestState commentStamp: 'SergioFedi 6/5/2015 20:44' prior: 0!
I model a mobile point in the story-space.
That is, where/how I am withing a story.
More speciffically, a Quest.
!

!QuestState class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/10/2015 07:10'!
on: aQuestMap 
	^ self new quest: aQuestMap.! !

!QuestState methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 06:54'!
currentNode
	^ currentNode.! !

!QuestState methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 07:05'!
currentNode: aStoryNode 
	currentNode := aStoryNode.! !

!QuestState methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:23'!
quest
	^ quest.! !

!QuestState methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 07:04'!
quest: aStoryMap 
	quest := aStoryMap.
	self currentNode: aStoryMap beginning.! !

Object subclass: #SJTGame
	instanceVariableNames: 'version locations playerCharacter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!SJTGame commentStamp: 'SergioFedi 8/19/2015 07:20' prior: 0!
I model a the game Server Jacked Transformations!

!SJTGame class methodsFor: 'examples' stamp: 'SergioFedi 9/4/2015 07:55'!
connect: location1 with: location2
	location1 addNeighbour: location2.
	location2 addNeighbour: location1! !

!SJTGame class methodsFor: 'examples' stamp: 'SergioFedi 9/23/2015 05:29'!
firstTownExample
	| example location1 location2 location3 location4 location5 location6 location7 location8 location9 location10 location11 |
	example := self new.
	example version: 'firstTownExample'.
	location1 := Location
		named: 'Town Gate Entry'
		description:
			'You stand at a surprisingly solid looking entryway; stone walls stretch in either direction, and the arch before you holds an iron gate firmly in place. An armoured cat-morph stands guard. He opens the gate and allows you in, to the North you hear the clanging of hammer to metal, and south you see the peak of a whitewashed chapel.'.
	example playerCharacter: (PlayerCharacter location: location1).
	location2 := Location
		named: 'Smithy'
		description:
			'A building of stone with an outdoor forge greets you, along with a sign that reads "Ms. Jackson''s Smithy" When you enter, the door chimes, and the smithy looks up from a workbench, taking off a surprisingly modern welding mask. A black lady with a bright orange faux-hawk and a masculine face and lean body greets you. "How can I help ya?"'.
	location3 := Location
		named: 'Chapel'
		description:
			'The quaint chapel you walk up to smells like flowers and ale, and when you enter, you see a likely-male robot in a hempen brown robe. "Greetings of the Data-spirits to you!!" he calls out, his voice surprisingly musical and human. He takes a gulp from a stein and hiccups, before settling on a bench. "Do you require assitance?"'.
	location4 := Location
		named: 'Town Square'
		description:
			'You reach what seems to be the town-square. In the centre is a fountain that runs with water; although the water is a bright purple. A sign points North to the Village Hall, South to the Pawnshop, and East to the Housing District and Town Exit.'.
	location5 := Location
		named: 'Village Hall'
		description:
			'The Village Hall looks like more like a modern house compared to the quaint stone buildings elsewhere. <Placeholder: Portals between towns/nodes/servers, questhub>'.
	location6 := Location
		named: 'Pawnshop'
		description:
			'The Pawnshop is less of a shop, more of a carriage. You don''t see a Horse anywhere to pull it, until the towering Minotaur steps around the corner. He''s easily two and a half metres of muscles, with wicked curling horns, and thick hooved feet. His fleshy upper-body is coated with a corase lining of black hair, though the Minotaur himself is bald. He takes a pondering step forward that makes the ground tremble, before clapping his hands together like crack of lightning. "HALLO COMRADE!! BE WELCOMED TO BORIS'' PAWN HUT". His bovine face breaks in to a wide grin. "PLEASE TO BE SELLING ME ALL YOUR SHIT!!"'.
	location7 := Location
		named: 'Housing District'
		description:
			'As you reach this portion of the town, you notice the number of buildings have increased; there''s living space, although it doesn''t all appear occupied. More interestingly, you can see a two-floored tavern with a sign hanging before it; The Sloppy Mug. To the south you see a building of plain stone, with chimneys letting out steam; the Public Baths.'.
	location8 := Location
		named: 'Tavern'
		description:
			'When you enter The Sloppy Mug, you''re awash in warmth from an open fire, the sound of gentle guitar playing (though no guitarist in sight), and the mouth-watering smell of food and drink. Stood at the counter sipping from a glass is an ash-grey Dogmorph, in the corner is a man with Raven wings, and lying down before the fire is the massive serpantine bulk of a Lamia girl.'.
	location9 := Location
		named: 'Tavern Upper Floor'
		description:
			'Upstairs are a number of rooms, from behind a closed door, you can hear two people crying out in the throes of passion, and at the far end is a voluptuous-looking girl of green goo, sat in a comfy chair with a ring of keys and a clipboard.'.
	location10 := Location
		named: 'Public baths'
		description:
			'Opening the doorway to the Public Baths bathes your face in the scent of steam and flowery soap. Peering through the muggy air you see a monstrous form scuttling towards you on Spider-Legs, the steam nearby it clears and reveals a demure woman with a towel wrapped around her chest, and at her hips where flesh meets Arachnid. Six softly-glowing red eyes look you up and down, and the Drider smiles. "Hello dear, welcome to the Baths" <Placeholder; Submitted NPCs will go here>'.
	location11 := Location
		named: 'Guard House'
		description:
			'The Guard House before you leads to the Town''s exit, but a sign sits before a closed door stating "Danger: Server Damage Ahead, zone inaccessible>'.
	example locations
		add: location1;
		add: location2;
		add: location3;
		add: location4;
		add: location5;
		add: location6;
		add: location7;
		add: location8;
		add: location9;
		add: location10;
		add: location11;
		yourself.
	self connect: location1 with: location2.
	self connect: location1 with: location3.
	self connect: location1 with: location4.
	self connect: location4 with: location5.
	self connect: location4 with: location6.
	self connect: location4 with: location7.
	self connect: location7 with: location8.
	self connect: location7 with: location10.
	self connect: location7 with: location11.
	self connect: location8 with: location9.
	^ example! !

!SJTGame class methodsFor: 'instance-creation' stamp: 'SergioFedi 9/23/2015 06:58'!
fromMemento: aSJTGameState
 
	| newSJTGame |
	newSJTGame := self perform: aSJTGameState version asSymbol.
	newSJTGame playerCharacter location: (newSJTGame locations detect: [:each | each = aSJTGameState location]).
	newSJTGame playerCharacter currentDialog: aSJTGameState dialogState.
	^newSJTGame.! !

!SJTGame class methodsFor: 'examples' stamp: 'SergioFedi 9/2/2015 06:34'!
singleLocationExample

	| locations |
	locations := (OrderedCollection with: (Location named: 'Town Gate Entry' description: 'You stand at a surprisingly solid looking entryway; stone walls stretch in either direction, and the arch before you holds an iron gate firmly in place. An armoured cat-morph stands guard. He opens the gate and allows you in, to the North you hear the clanging of hammer to metal, and south you see the peak of a whitewashed chapel.')).
	^self new
		locations: locations;
		playerCharacter: (PlayerCharacter location: locations first);
		version: 'singleLocationExample';
		yourself.! !

!SJTGame class methodsFor: 'examples' stamp: 'SergioFedi 9/22/2015 07:25'!
singleLocationWithNPCExample

	| example |
	example := self singleLocationExample.
	example locations first addNPC: NPC lonelyNPC.
	example version: 'singleLocationWithNPCExample'.
	^example.! !

!SJTGame class methodsFor: 'examples' stamp: 'SergioFedi 9/2/2015 06:35'!
twoLocationsExample

	| example location1 location2 |
	example := self singleLocationExample.
	example version: 'twoLocationsExample'.
	location1 := example locations first.
	location2 := Location
		named: 'Town Square'
		description: 'You reach what seems to be the town-square. In the centre is a fountain that runs with water; although the water is a bright purple. A sign points North to the Village Hall, South to the Pawnshop, and East to the Housing District and Town Exit.'.
	example locations add: location2.
	location1 addNeighbour: location2.
	location2 addNeighbour: location1.
	^example.! !

!SJTGame class methodsFor: 'examples' stamp: 'SergioFedi 9/22/2015 07:25'!
twoLocationsWithNPCExample

	| example |
	example := self twoLocationsExample.
	example locations second addNPC: NPC lonelyChattyNPC.
	example version: 'twoLocationsWithNPCExample'.
	^example.! !

!SJTGame methodsFor: 'public' stamp: 'SergioFedi 9/23/2015 07:04'!
dialogNodes

	^self npcs
		inject: OrderedCollection new
		into: [:nodes :npc |
			nodes addAll: npc dialogNodes.
			].! !

!SJTGame methodsFor: 'initialization' stamp: 'SergioFedi 9/2/2015 06:32'!
initialize

	super initialize.
	self locations: OrderedCollection new.
	self version: 'new'.! !

!SJTGame methodsFor: 'testing' stamp: 'SergioFedi 9/4/2015 23:11'!
isValid

	^((self locations notNil
	and: [self playerCharacter notNil])
	and: [self version isString])
	and: [self locations identityIncludes: self playerCharacter location].! !

!SJTGame methodsFor: 'accessors' stamp: 'SergioFedi 8/28/2015 23:13'!
locations
	^ locations! !

!SJTGame methodsFor: 'accessors' stamp: 'SergioFedi 8/20/2015 07:44'!
locations: aCollection

	locations := aCollection.! !

!SJTGame methodsFor: 'public' stamp: 'SergioFedi 9/22/2015 07:14'!
npcs

	^self locations inject: OrderedCollection new into: [:npcs :location |
		npcs addAll: location npcs. npcs.].! !

!SJTGame methodsFor: 'public' stamp: 'SergioFedi 9/16/2015 07:54'!
optionsForPlayerCharacter

	| options |
	options := OrderedCollection new.
	options addAll: self optionsForPlayerCharacterMovingToNeighbours.
	options addAll: self optionsForPlayerCharacterInteractingWithNPCs.
	^options.! !

!SJTGame methodsFor: 'public' stamp: 'SergioFedi 9/23/2015 04:49'!
optionsForPlayerCharacterInteractingWithNPCs

	^self playerCharacter isInDialog
		ifTrue: [
			self playerCharacter currentDialog options isEmpty 
				ifTrue: [Array with: (FinishDialog in: self)]
				ifFalse: [self playerCharacter currentDialog options collect: [:dialogOption |
					ChooseDialogOption in: self option: dialogOption	]]]
		ifFalse: [
			self playerCharacter location npcs collect: [:npc | 
				InteractWithNPC in: self npc: npc]].! !

!SJTGame methodsFor: 'public' stamp: 'SergioFedi 9/22/2015 07:46'!
optionsForPlayerCharacterMovingToNeighbours

	self playerCharacter isInDialog ifTrue: [ ^#() ].
	^self playerCharacter location neighbours collect: [:location | MoveAction in: self to: location for: self playerCharacter].! !

!SJTGame methodsFor: 'accessors' stamp: 'SergioFedi 8/20/2015 09:03'!
playerCharacter
	^ playerCharacter! !

!SJTGame methodsFor: 'accessors' stamp: 'SergioFedi 8/20/2015 07:46'!
playerCharacter: aPlayerCharacter

	playerCharacter := aPlayerCharacter.! !

!SJTGame methodsFor: 'public' stamp: 'SergioFedi 9/23/2015 05:49'!
state

	^SJTGameState 
		location: self playerCharacter location 
		version: self version
		dialog: self playerCharacter currentDialog.! !

!SJTGame methodsFor: 'accessors' stamp: 'SergioFedi 9/2/2015 06:33'!
version
	^ version! !

!SJTGame methodsFor: 'accessors' stamp: 'SergioFedi 9/2/2015 06:33'!
version: aString 
	version := aString! !

Object subclass: #SJTGameAction
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

SJTGameAction subclass: #ChooseDialogOption
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!ChooseDialogOption class methodsFor: 'instance creation' stamp: 'SergioFedi 9/23/2015 04:51'!
in: aSJTGame option: aDialogOption

	^(super in: aSJTGame)
		option: aDialogOption;
		yourself.! !

!ChooseDialogOption methodsFor: 'public' stamp: 'SergioFedi 9/24/2015 06:40'!
description

	^self option description.! !

!ChooseDialogOption methodsFor: 'private' stamp: 'SergioFedi 9/23/2015 04:51'!
option
	^ option! !

!ChooseDialogOption methodsFor: 'private' stamp: 'SergioFedi 9/23/2015 04:51'!
option: anObject
	option := anObject! !

!ChooseDialogOption methodsFor: 'public' stamp: 'SergioFedi 9/29/2015 18:49'!
perform

	self game playerCharacter currentDialog: self option node.! !

!ChooseDialogOption methodsFor: 'public' stamp: 'SergioFedi 10/7/2015 18:38'!
redefineForGame: aSJTGame

	| dialogNode |
	super redefineForGame: aSJTGame.
	dialogNode := aSJTGame dialogNodes detect: [:each | each = self option node].
	self option node: dialogNode.! !

SJTGameAction subclass: #FinishDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!FinishDialog methodsFor: 'public' stamp: 'SergioFedi 9/24/2015 06:35'!
description

	^'End dialog'.! !

!FinishDialog methodsFor: 'public' stamp: 'SergioFedi 9/22/2015 08:05'!
perform

	self game playerCharacter currentDialog: nil.! !

SJTGameAction subclass: #InteractWithNPC
	instanceVariableNames: 'npc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!InteractWithNPC class methodsFor: 'instance creation' stamp: 'SergioFedi 9/16/2015 08:03'!
in: aSJTGame npc: aNPC

	^self new
		initializeWithGame: aSJTGame npc: aNPC;
		yourself.! !

!InteractWithNPC methodsFor: 'public' stamp: 'SergioFedi 9/24/2015 06:48'!
description

	^'Talk to ', self npc name.! !

!InteractWithNPC methodsFor: 'private' stamp: 'SergioFedi 9/16/2015 08:04'!
initializeWithGame: aSJTGame npc: aNPC

	game := aSJTGame.
	npc := aNPC.! !

!InteractWithNPC methodsFor: 'private' stamp: 'SergioFedi 9/22/2015 07:21'!
npc
	^ npc! !

!InteractWithNPC methodsFor: 'private' stamp: 'SergioFedi 9/22/2015 07:21'!
npc: aNPC 
	npc := aNPC! !

!InteractWithNPC methodsFor: 'public' stamp: 'SergioFedi 9/22/2015 07:23'!
perform

	self npc dialog isNil ifTrue: [ ^self ].
	self game playerCharacter currentDialog: self npc dialog.! !

!InteractWithNPC methodsFor: 'public' stamp: 'SergioFedi 10/7/2015 18:31'!
redefineForGame: aSJTGame

	super redefineForGame: aSJTGame.
	self npc: (aSJTGame npcs detect: [:each | each name = self npc name])! !

SJTGameAction subclass: #MoveAction
	instanceVariableNames: 'destination character'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!MoveAction class methodsFor: 'instance creation' stamp: 'SergioFedi 10/7/2015 18:57'!
in: aGame to: aLocation for: aCharacter

	^(super in: aGame)
		destination: aLocation;
		character: aCharacter;
		yourself.! !

!MoveAction methodsFor: 'private' stamp: 'SergioFedi 8/28/2015 23:27'!
character: aCharacter

	character := aCharacter.! !

!MoveAction methodsFor: 'public' stamp: 'SergioFedi 9/2/2015 08:06'!
description

	^'Move towards ', self destination name.! !

!MoveAction methodsFor: 'public' stamp: 'SergioFedi 8/28/2015 23:35'!
destination
	^ destination! !

!MoveAction methodsFor: 'private' stamp: 'SergioFedi 8/28/2015 23:27'!
destination: aLocation

	destination := aLocation.! !

!MoveAction methodsFor: 'public' stamp: 'SergioFedi 8/28/2015 23:32'!
perform

	character location: destination.! !

!MoveAction methodsFor: 'public' stamp: 'SergioFedi 10/7/2015 18:38'!
redefineForGame: aSJTGame

	super redefineForGame: aSJTGame.
	self destination: (aSJTGame locations detect: [:each | each name = self destination name]).
	self character: aSJTGame playerCharacter.! !

!SJTGameAction class methodsFor: 'instance creation' stamp: 'SergioFedi 9/22/2015 08:02'!
in: aSJTGame

	^self new
		game: aSJTGame;
		yourself.! !

!SJTGameAction methodsFor: 'public' stamp: 'SergioFedi 10/7/2015 19:00'!
description
	
	self subclassResponsibility ! !

!SJTGameAction methodsFor: 'private' stamp: 'SergioFedi 9/22/2015 08:02'!
game
	^ game! !

!SJTGameAction methodsFor: 'private' stamp: 'SergioFedi 9/22/2015 08:02'!
game: aSJTGame 
	game := aSJTGame! !

!SJTGameAction methodsFor: 'public' stamp: 'SergioFedi 9/29/2015 19:07'!
perform

	self subclassResponsibility ! !

!SJTGameAction methodsFor: 'public' stamp: 'SergioFedi 10/7/2015 18:27'!
redefineForGame: aSJTGame

	self game: aSJTGame.! !

Object subclass: #SJTGameController
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!SJTGameController commentStamp: 'SergioFedi 8/27/2015 07:36' prior: 0!
I model the functional interface between a player and his PlayerCharacter in the SJTGame.

That is, I am the one who provides the information the player sees about his character and the game and mediates the actions he takes through his character.
!

!SJTGameController class methodsFor: 'instance creation' stamp: 'SergioFedi 8/20/2015 07:49'!
on: aSJTGame

	^self new
		game: aSJTGame;
		yourself.! !

!SJTGameController methodsFor: 'public' stamp: 'SergioFedi 8/28/2015 23:31'!
choose: anAction

	anAction perform.! !

!SJTGameController methodsFor: 'accessors' stamp: 'SergioFedi 8/20/2015 09:03'!
game
	^ game! !

!SJTGameController methodsFor: 'accessors' stamp: 'SergioFedi 8/20/2015 07:50'!
game: aSJTGame

	game := aSJTGame.! !

!SJTGameController methodsFor: 'public' stamp: 'SergioFedi 8/27/2015 07:46'!
location
	^ self playerCharacter location! !

!SJTGameController methodsFor: 'public' stamp: 'SergioFedi 8/27/2015 07:47'!
locationDescription
	^ self location description! !

!SJTGameController methodsFor: 'public' stamp: 'SergioFedi 8/27/2015 07:46'!
locationName
	^ self location name! !

!SJTGameController methodsFor: 'public' stamp: 'SergioFedi 8/28/2015 23:15'!
options

	^self game optionsForPlayerCharacter.! !

!SJTGameController methodsFor: 'public' stamp: 'SergioFedi 8/27/2015 07:46'!
playerCharacter
	^ self game playerCharacter! !

!SJTGameController methodsFor: 'public' stamp: 'SergioFedi 8/31/2015 08:12'!
state

	^self game state.! !

Object subclass: #SJTGameState
	instanceVariableNames: 'version location dialogState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!SJTGameState commentStamp: 'SergioFedi 8/29/2015 09:56' prior: 0!
I model the state of an SJTGame.

I'm an implementation of the pattern Memento.!

!SJTGameState class methodsFor: 'instance-creation' stamp: 'SergioFedi 9/23/2015 05:46'!
location: aLocation version: aString dialog: aDialogNode

	^self new
		initializeWithLocation: aLocation version: aString dialogState: aDialogNode;
		yourself.! !

!SJTGameState methodsFor: 'comparing' stamp: 'SergioFedi 9/23/2015 05:52'!
= anObject
	^ (self version = anObject version and: [ self location = anObject location ])
		and: [ self dialogState = anObject dialogState ]! !

!SJTGameState methodsFor: 'accessing' stamp: 'SergioFedi 9/23/2015 05:45'!
dialogState
	^ dialogState! !

!SJTGameState methodsFor: 'accessing' stamp: 'SergioFedi 9/23/2015 05:45'!
dialogState: anObject
	dialogState := anObject! !

!SJTGameState methodsFor: 'comparing' stamp: 'SergioFedi 9/23/2015 05:53'!
hash

	^ (self location hash bitXor: self version hash) bitXor: self dialogState hash.! !

!SJTGameState methodsFor: 'initialization' stamp: 'SergioFedi 9/16/2015 07:04'!
initializeWithLocation: aLocation version: aString

	location := aLocation.
	version := aString.
	
! !

!SJTGameState methodsFor: 'initialization' stamp: 'SergioFedi 9/23/2015 05:48'!
initializeWithLocation: aLocation version: aString dialogState: aDialogNode 

	location := aLocation.
	version := aString.
	dialogState := aDialogNode.	
! !

!SJTGameState methodsFor: 'accessing' stamp: 'SergioFedi 8/29/2015 10:00'!
location
	^ location! !

!SJTGameState methodsFor: 'instance creation' stamp: 'SergioFedi 8/31/2015 10:14'!
newGame

	^SJTGame fromMemento: self.! !

!SJTGameState methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/23/2015 05:21'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(.
	self location ifNotNil: [:aLocation | aStream nextPutAll: aLocation name ].
	aStream nextPut: $).
	! !

!SJTGameState methodsFor: 'accessing' stamp: 'SergioFedi 9/2/2015 06:38'!
version
	^ version! !

Object subclass: #SJTGameStateTransition
	instanceVariableNames: 'origin destination action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!SJTGameStateTransition commentStamp: 'SergioFedi 8/31/2015 11:13' prior: 0!
I model the transition from an SJTGameState to another through an action!

!SJTGameStateTransition class methodsFor: 'instance creation' stamp: 'SergioFedi 9/1/2015 16:00'!
origin: aSJTGameState destination: aSJTGameState2 action: anAction

	^self new
		origin: aSJTGameState;
		destination: aSJTGameState2;
		action: anAction;
		yourself.! !

!SJTGameStateTransition methodsFor: 'accessing' stamp: 'SergioFedi 9/2/2015 08:02'!
action
	^ action! !

!SJTGameStateTransition methodsFor: 'accessors' stamp: 'SergioFedi 9/1/2015 16:01'!
action: anAction
	action := anAction! !

!SJTGameStateTransition methodsFor: 'accessors' stamp: 'SergioFedi 9/1/2015 16:14'!
destination
	^ destination! !

!SJTGameStateTransition methodsFor: 'accessors' stamp: 'SergioFedi 9/1/2015 16:01'!
destination: aSJTGameState 
	destination := aSJTGameState! !

!SJTGameStateTransition methodsFor: 'accessors' stamp: 'SergioFedi 9/1/2015 16:03'!
origin
	^ origin! !

!SJTGameStateTransition methodsFor: 'accessors' stamp: 'SergioFedi 9/1/2015 16:00'!
origin: aSJTGameState 
	origin := aSJTGameState! !

Object subclass: #StoryMap
	instanceVariableNames: 'nodes beginning transitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!StoryMap commentStamp: 'FedericoFigueredo 6/1/2015 07:36' prior: 0!
StoryMap se define como el conjunto de pedacitos de ficción/historia y las formas en las que estos se relacionan entre si.!

!StoryMap class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/23/2015 07:19'!
dansExample
	| map 
	introductionNode 
	genderMaleNode 
	genderFemaleNode 
	maleScene1Node 
	femaleScene1Node 
	maleScene2Node 
	femaleScene2Node 
	maleScene3Node 
	femaleScene3Node 
	maleScene4Node 
	femaleScene4Node 
	theEndNode |
	map := StoryMap new.	"Defined nodes: Introduction is the start of the story, the main bulk, Gendermale and Genderfemale and their accompanying scene nodes are the only options right now, and based on which you pick you’ll get a different story."
	introductionNode := StoryNode
		text:
			'You grimace and hop backwards until you’re leant against the wall, just in time to avoid the murky puddle kicked up by a passing car. You nearly trip over your shopping bag as you pick up the pace; it’ll rain again pretty soon.

And it’s never good to be caught in the rain, it’s so toxic it cuts a few years off.

As you reach your apartment block, a deep rumble in the clouds cast your eyes upwards, skyscrapers pierce the clouds, and neon signs blare with enough strength to give you a headache.

Apparently things used to be better, but you’re pretty sure you’ve never even seen a for real no-fucking-kidding tree around here in the corporate hub. There used to be job prospects, and more to life than the net.

Not that you mind the net, you push open the rusty entrance to your block, and duck in just as the rain begins to fall. The lift ahead is out; you heft the weight of the bag in your hand, reluctantly climbing the stairs. As you pass one of the rooms on the way up, you can hear what’s either a couple going at it, or someone has their porn too loud.

You steel yourself and carry on before you’re caught outside listening in. Eventually you reach your own door, panting for breath.

The Corporations may have let the buildings around them decline into a grim old shit hole, but you at least try to keep the place tidy… Well, tidy-ish. At least you don’t seem to have any rodents. After all, it’s a small studio; you’ve got the means to live, a little bathroom, and on the other side of the room, completely at odds with your basic furniture, rests a beautiful box of polished chrome.

You feel a swell of pride in your stomach at the sheer sight of your beloved beast. You can practically feel the net-jack behind your ear grow warm in anticipation. It’s all you can do to unpack your shopping; admittedly it’s nothing but instant ramen, energy drinks, and coffee. But that stuff can be heavy.

You go through the process of throwing off your gross street-clothes and pulling on something comfy. You take a look in the mirror just as you toss your jacket into the corner, eyeing yourself up. But what are you?'.
	genderMaleNode := StoryNode
		text:
			'You’re a guy, and you’re packing the cock to prove it at least. You give yourself a once-over as you turn around in the mirror and tug on a shirt and some baggy jeans. How do you look?'.
	genderFemaleNode := StoryNode
		text:
			'You’re a girl, with the breasts and pussy to prove it at the least. You give yourself a once-over as you turn around in the mirror and tug on a shirt and some baggy jeans. How do you look?'.
	maleScene1Node := StoryNode
		text:
			'You’re proud to prove malnutrition and science wrong with your toned body, no matter what you put away you’ve always seemed to possess some muscle density and clean features.

You flash yourself the finger pistols. If your mother were still about she’d scold you for looking lazy. But it’s your place!! You paid for it with your own hard earned cash.

Well, mostly hard-earned. You’re just about paying the bills and not dying of starvation. You’ve found that poking at the less ‘Iced’ parts of corporate nets will give you enough information to sell for a living. It’s not risk free of course, but you’ve yet to have suits crash in to your home and mysteriously disappear you.

You drop in to your chair, sighing as you feel it practically hug your buns. You stare at the machine before you; a beautiful box of technology. Along the bottom of it, drawn on in your own scribbly hand, is the ink drawing of an animal.'.
	femaleScene1Node := StoryNode
		text:
			'You’ve always been undeniably curvy, the calories only go to your favourite bits. Mother would be so proud.

You flash yourself the finger pistols. But if your mother were still about she’d also scold you for looking lazy. But it’s your place!! You paid for it with your own hard earned cash.

Well, mostly hard-earned. You’re just about paying the bills and not dying of starvation. You’ve found that poking at the less ‘Iced’ parts of corporate nets will give you enough information to sell for a living. It’s not risk free of course, but you’ve yet to have suits crash in to your home and mysteriously disappear you.

You drop in to your chair, sighing as you feel it practically hug your buns. You stare at the machine before you; a beautiful box of technology. Along the bottom of it, drawn on in your own scribbly hand, is the ink drawing of an animal.'.
	maleScene2Node := StoryNode
		text:
			'Ah the faithful dog. Resilient and loyal. You slide a cord from the side of your computer, stroking the jack with your fingers. You take a soft breath, holding it in. It’s always felt like this, deep down inside; a churning in your stomach right before you hook up.

The moment the jack of the cord meets the one behind your ear, your hands fall into your lap. The breath you hold escapes in a yawn as you sink into the warm embrace of data. Your body grows warm, and the churning in your stomach settles to a calm sea.

You open eyes you didn’t even realise had even closed, and look about yourself. All around is the architecture of your computer; it always looks like a richly furnished lounge, surrounded by obelisks of processing and data. It has always felt like your real home; your fortress.

You feel that fortress look you over, cautiously. That’s your own fault; you made sure to keep the Beast paranoid. You don’t always encounter the friendliest types when you make a living hacking big scary corps. After a few moments, a door opens, and you feel yourself being pulled inside like an old friend who hasn’t visited in months.

You could start some games from here, but there’s only one thing you’re really interested in doing in your time off.

You feel a presence at your feet, and crouch, hands spreading wide. A jet black Husky dog all but pounces on you, licking at your neck. It feels real enough, every sensation of your body is cranked up to eleven when you’re jacked into a computer. After a little, the dog settles back, wolfy features and eyes quite literally glowing with intelligence.

“Welcome back Master” it seems to say, the words echoing in your head with warmth. You grin and point at a door, and the Beast pads its way over, tail wagging.

“We’re going for a walkies” you say proudly. It’s a joke you never get tired of telling. The door seems to sit at the end of your lounge, and it’s the entrance to the net itself. It’s impossible to traverse with just your own intelligence. Humans aren’t made to cope with that density of information. Once you’re on a server it’s no problem, you can adjust. But in order to get from one to the other. You need a companion.

You smile fondly at the Beast, opening the door and jumping in to the white light that shines out. The Beast follows after you, leaping into the opening. For a brief, panic-ridden moment you’re afloat in a cascade of numbers. But you feel the invisible leash of your companion around your wrist, and the world goes still.

Instead there are tunnels, tunnels to endless possibilities. At the speed of thought you’re hurtling down tubes connected to polyhedrons of various faces. You take the familiar bookmarked routes, and the white light swaps to a pitch blackness. It used to be scary, but you’ve done it so often it’s even easier than breathing.

You jump through a few proxies, and in what feels like a minute on the net, you know only seconds have passed in reality. You reach the next proxy and pause. You can feel it deep down, and the Beast confirms it. You press your hands against a sheet black surface, like polished obsidian in a tunnel of nothing. 

Your entire body seems to glitch as you lag for the barest few moments. Your breath catches, and then  a crack spreads in the wall. You knock, it’s only polite, and the wall shatters, turning into a door that you step through, the Beast on your heels.

And now you’re in the hub of humanity’s greatest depravities. Heck, by this point you’ve probably taken part in most of them.

What looks like a man of twenty, with the ears of a dog, steps out in front of you.

“Greetings sir, do you have a login?”

You’re a little caught off guard, and stumble, back. But you confirm that you do, and a moment later the man grins. His official demeanour slips as his own UI likely confirms you, and you even catch the hint of a tail wagging.

“Cheers buddy. I hate playing strongarm. I know, I know. This is no Light-net authenticated user bollocks, but there’ve been some weird sorts about”

You look around, and watch twenty mice pour out of a casino, before bursting into flames. Nooby hackers never learn. The dogman follows your gaze and chuckles.

“I know!! Weird even for here. But seriously, I mean it. I hear we’ve got Pirates. And not the kind that can score raunchy flicks, but the Black-Ops information hustling kind. Rumour says they’ve even got some dudes working in meatspace ganking anyone who tries to figure them out. So yeah, authenticated people only for now, we don’t need that kinda flak”.

You’re about to ask him for more information, but the Dog-Man’s ears twitch, and you hear a pinging noise.

“Sorry buddy, gotta bounce. There’s a sexy slice of puss with this pup’s name on it”

He waves apologetically and scampers off. Next stop, you suppose. You take a moment to look over the whole hub. It’s a central point for people on the Dark Net. a Corporation-free haven for the info-trade. Well, mostly corp free. You know they’ve got men on the inside, but you’ve yet to meet one.

On the net your body has needs, and can feel all the sensations. There’s no end of sex-trade, alcohol-drinking, and monster fighting to get up to. Sometimes they’re all the same at once, the Dark Net gets pretty dangerous. You head towards an information board and look up news on these new Pirates though.

It takes a little browsing, most of the information is bunk rumour-mongering, but this is the kind of thing you’re trained in taking apart. Eventually you find a node that’s seen a lot more action. You find a proxy door, and head out, with the Beast at your side.

Instead of another hub town, you find yourself with an open field. You’re sure this isn’t right, you were looking for some kind of base of operations, or at the least a busy info-bar. But this is a straight-up fantasy field.

“Oi!!” calls a thickly accented voice.

Your Beast growls, hackles rising. You turn to meet the voice, already thinking of ways to defend yourself. Instead of some kind of poorly dressed internet-pirate, you’re faced with a stunning visage in a black skintight bodysuit. Your brain almost can’t register their gender but the mere sight of them sends your sex drive skyrocketing in to uncontrollable heights.'.
	maleScene3Node := StoryNode
		text:
			'It’s a guy, it couldn’t be anything but a guy. His skin is of purest obsidian, his ears are elfin, and though his features are feminine, you can see the bulge against his pants. There must be eight inches of the monster there, and your eyes are caught between staring at it or being lost in the stranger’s own eyes.

You take a deep breath and try to speak, but the man holds his finger to his lips in a soft “Shh” and your body falls still. You’re fairly certain something’s been done to you, none of your limbs are moving.

“Now that I have your undivided attention. Please, do remain still and let me take a good look at you”

You’re not sure how to react, but it’s hard to focus as the man takes step after step closer to you. He looks down at your dog however, and sighs. He sweeps his hand and the Beast is dispersed like dust in the wind.

This sets off alarm bells in your head and you try to run; you’re a sitting duck without your UI and somehow they’ve been separated from you. Your body refuses to answer your call to motion. You’re bound by nothingness, as though sealed in stone. You are, however, growing rock hard. You’re not sure if you can blame that on hacking or your own net-enhanced sensations. 

You look up and gulp, heat rushing to your cock as your body breaks out in a flush. The mystery man is close enough that your noses are almost touching. He runs his hands through your hair and hauls you into an aggressive kiss. His tongue forces your mouth open and explores. Your hair is tugged back on and you’re entirely at his whims. Every overactive nerve in your body is sent into overdrive as you struggle to keep up with the assault on your senses.

You feel nails dig into your chest, and your clothes are torn away, your manhood is hard, blood rushing through it with a purpose. Every part of you is begging for another touch as the man steps back. He draws his fingers through his short blonde hair, and deep purple eyes rend a hole through your being.

“You’re looking for us” he says.

You struggle to take in the information, mumbling a weak “pardon?” before he pushes you over. You fall on to your rear and he leans over.

“I said, you’re looking for us. Our group. You think we don’t have anyone keeping an eye out?”

He sighs and drops to his knees, hands wrapping around your cock. It’s all a surprise, and you don’t know how to react. It’s only a few moments of vicious jerking and you coat his palm in spunk, your entire being trembling with the force of the orgasm.

You’ve never felt so helpless, and the man shakes his hand out, flicking your own spunk on to your body as he bends down.

“Sorry, it’s time for you to taste a little reality” he says, licking the rest of his hand clean.

The entire time you’ve been unable to muster a single word, but everything reboots before you can form a word.

In a moment of bleak nothing, you find yourself in meatspace, your real body is sprawled out on the floor. Your data jack is dangling from your computer with no home, and the port behind your ear feels like it’s burning.

A resounding crash draws your attention to your door. Two men in suits are kicking their way in, and they look over you. Your baggy shirt is glued to your stomach with cum, and you can’t move a single limb of your body. Instead of words, you’re forced to hold back the need to throw up.

“Sorry” one of them says as they haul you up and you begin to black out again.'.
	maleScene4Node := StoryNode
		text:
			'It’s a woman. It couldn’t be anything but. She must have double F cups and her lips are trapped in a cocksucking pout. Her breasts are loveably huge and her hips sway with the confidence that only befit a woman with an ass that could end wars. Deep purple eyes peer out from a frame of obsidian skin, topped with braided white hair.

“You’d think they’d be smart enough to avoid abduction zones, instead of be drawn to them like flies. Why did you look for us?”

She steps closer and every alarm in your body ratchets up another level. She smiles casually and throws her arms up in to the air as though conducting an orchestra. The Beast by your side is dispersed like dust on the wind and your alarm turns to full blown panic. Without your UI you’re all but trapped on this server.

It’s almost unheard of by this point, but before you can form a coherent sentence her hands are threaded through your hair, and you’re pulled in close to her. She kisses you hard, tongue wrestling with yours as she explores every taste your mouth has to offer.

She pulls back, and when you gasp for air you didn’t know you needed, she’s licking her lips. “Much better. It’s just you, and me”. She pushes you to the ground and drops to all fours, crawling towards you. She grips at your clothing and pulls her hands apart. Instead of removing it, you’re rendered immediately naked. Her eyes bore into yours and she takes your manhood in a surprisingly soft grip. After a few jerks, any attempt at speech is rendered impossible in a series of groans.

The parts of you that should be saying this is impossible are suppressed as she crouches down. Her womanhood is brushing over the hardness of your cock, clear against the tightness of her bodysuit. You bite down hard on your lip, trying to process anything at all.

She grinds, just once, a single confident motion from the base of your lance to the tip, and your body gives in, painting her cunt and thighs ivory with your seed. You gasp desperately for breath, and the edges of your vision begin to blur. The woman only coos above you. Purple eyes that judge every inch of your digital body cast up and down you. She stands up, hand wiping spunk from skintight clothing.

“Over so soon!! Not that I’m surprised, you look a little… Off guard. That’s dangerous, did nobody ever teach you to defend yourself?” she asks, licking her hand. “Good luck on the other side” she says.

You’ve never been forced out of the digital world before, but you find yourself in meatspace, sprawled on the floor away from your computer, clothes shamefully sticky. The net jack behind your ear feels hot enough to burn and you’re trying exceptionally hard not to just throw up.

Your door is kicked viciously open, but the sound seems muted, and you’re fairly sure you’re blacking out. Maybe you hit your head. Two suited men walk in and scoop you up by the arms and legs. You’re unsure, but you think one of them apologises.

And then nothingness.'.
	femaleScene2Node := StoryNode
		text:
			'Ah the faithful dog. Resilient and loyal. You slide a cord from the side of your computer, stroking the jack with your fingers. You take a soft breath, holding it in. It’s always felt like this, deep down inside; a churning in your stomach right before you hook up.

The moment the jack of the cord meets the one behind your ear, your hands fall into your lap. The breath you hold escapes in a yawn as you sink into the warm embrace of data. Your body grows warm, and the churning in your stomach settles to a calm sea.

You open eyes you didn’t even realise had even closed, and look about yourself. All around is the architecture of your computer; it always looks like a richly furnished lounge, surrounded by obelisks of processing and data. It has always felt like your real home; your fortress.

You feel that fortress look you over, cautiously. That’s your own fault; you made sure to keep the Beast paranoid. You don’t always encounter the friendliest types when you make a living hacking big scary corps. After a few moments, a door opens, and you feel yourself being pulled inside like an old friend who hasn’t visited in months.

You could start some games from here, but there’s only one thing you’re really interested in doing in your time off.

You feel a presence at your feet, and crouch, hands spreading wide. A jet black Husky dog all but pounces on you, licking at your neck. It feels real enough, every sensation of your body is cranked up to eleven when you’re jacked into a computer. After a little, the dog settles back, wolfy features and eyes quite literally glowing with intelligence.

“Welcome back Master” it seems to say, the words echoing in your head with warmth. You grin and point at a door, and the Beast pads its way over, tail wagging.

“We’re going for a walkies” you say proudly. It’s a joke you never get tired of telling. The door seems to sit at the end of your lounge, and it’s the entrance to the net itself. It’s impossible to traverse with just your own intelligence. Humans aren’t made to cope with that density of information. Once you’re on a server it’s no problem, you can adjust. But in order to get from one to the other. You need a companion.

You smile fondly at the Beast, opening the door and jumping in to the white light that shines out. The Beast follows after you, leaping into the opening. For a brief, panic-ridden moment you’re afloat in a cascade of numbers. But you feel the invisible leash of your companion around your wrist, and the world goes still.

Instead there are tunnels, tunnels to endless possibilities. At the speed of thought you’re hurtling down tubes connected to polyhedrons of various faces. You take the familiar bookmarked routes, and the white light swaps to a pitch blackness. It used to be scary, but you’ve done it so often it’s even easier than breathing.

You jump through a few proxies, and in what feels like a minute on the net, you know only seconds have passed in reality. You reach the next proxy and pause. You can feel it deep down, and the Beast confirms it. You press your hands against a sheet black surface, like polished obsidian in a tunnel of nothing. 

Your entire body seems to glitch as you lag for the barest few moments. Your breath catches, and then  a crack spreads in the wall. You knock, it’s only polite, and the wall shatters, turning into a door that you step through, the Beast on your heels.

And now you’re in the hub of humanity’s greatest depravities. Heck, by this point you’ve probably taken part in most of them.

What looks like a man of twenty, with the ears of a dog, steps out in front of you.

“Greetings sir, do you have a login?”

You’re a little caught off guard, and stumble, back. But you confirm that you do, and a moment later the man grins. His official demeanour slips as his own UI likely confirms you, and you even catch the hint of a tail wagging.

“Cheers buddy. I hate playing strongarm. I know, I know. This is no Light-net authenticated user bollocks, but there’ve been some weird sorts about”

You look around, and watch twenty mice pour out of a casino, before bursting into flames. Nooby hackers never learn. The dogman follows your gaze and chuckles.

“I know!! Weird even for here. But seriously, I mean it. I hear we’ve got Pirates. And not the kind that can score raunchy flicks, but the Black-Ops information hustling kind. Rumour says they’ve even got some dudes working in meatspace ganking anyone who tries to figure them out. So yeah, authenticated people only for now, we don’t need that kinda flak”.

You’re about to ask him for more information, but the Dog-Man’s ears twitch, and you hear a pinging noise.

“Sorry buddy, gotta bounce. There’s a sexy slice of puss with this pup’s name on it”

He waves apologetically and scampers off. Next stop, you suppose. You take a moment to look over the whole hub. It’s a central point for people on the Dark Net. a Corporation-free haven for the info-trade. Well, mostly corp free. You know they’ve got men on the inside, but you’ve yet to meet one.

On the net your body has needs, and can feel all the sensations. There’s no end of sex-trade, alcohol-drinking, and monster fighting to get up to. Sometimes they’re all the same at once, the Dark Net gets pretty dangerous. You head towards an information board and look up news on these new Pirates though.

It takes a little browsing, most of the information is bunk rumour-mongering, but this is the kind of thing you’re trained in taking apart. Eventually you find a node that’s seen a lot more action. You find a proxy door, and head out, with the Beast at your side.

Instead of another hub town, you find yourself with an open field. You’re sure this isn’t right, you were looking for some kind of base of operations, or at the least a busy info-bar. But this is a straight-up fantasy field.

“Oi!!” calls a thickly accented voice.

Your Beast growls, hackles rising. You turn to meet the voice, already thinking of ways to defend yourself. Instead of some kind of poorly dressed internet-pirate, you’re faced with a stunning visage in a black skintight bodysuit. Your brain almost can’t register their gender but the mere sight of them sends your sex drive skyrocketing in to uncontrollable heights.'.
	femaleScene3Node := StoryNode 
		text: 'It’s a guy, it couldn’t be anything but a guy. His skin is of purest obsidian, his ears are elfin, and though his features are feminine, you can see the bulge against his pants. There must be eight inches of the monster there, and your eyes are caught between staring at it or being lost in the stranger’s own eyes.

He sighs, walking towards you. You try to take a step back but your body refuses to play along. He waves and speaks up “Ah!! Another one I see, perhaps you’ll be more entertaining”.

He casts his hands wide and The Beast at your side is suddenly dispersed like dust in the wind. Your worry is sent into a full blown panic, and your limbs refuse to take commands, stuck as though held fast in cement. The only thing you can feel is a growing heat in your crotch, moisture running down the inside of your leg. It almost tickles but you can’t do anything about it.

“Much better, just you and me” he says. You blink, and when your eyes open his hands are on your cheeks, holding your face fast when you try to flinch. Shining purple eyes bore into you, and the man looks down. He grins and grabs you chest roughly, giving your tits a squeeze.

You gasp and nearly bite down on your tongue, he gives your nipples a flick that leaves them harder than diamonds, and his hands travel down to your pants. Instead of tug them off however, he just pulls them apart with as much effort as he would with tissue paper. Your bare soaking slit is assaulted roughly by his fingers, which are immediately soaked with your excitement. His thumb grinds on your clit and your body feels like it’s exploding, a helpless squirt of girlcum soaking his hand as he pushes you to the ground.

You see the world begin to grow dark around the edges as the man licks his hand clean, smirking. “That’s too bad, still, amusing enough. Good luck on the other side”.

Before you can ask what he means, you feel yourself being vigorously booted out of the net, when your eyes open, you’re sprawled out helplessly on the floor, the net jack behind your ear is burning hot. You pant for breath and fight back the sensation of nausea.

Your door is blasted open with a forceful kick, but you’re able to do little more than wriggle on the floor, legs damp with cooling excitement as you begin to black out for real. Two suited figures pick you up, one of them mutters you a gentle “Sorry”.'.
	femaleScene4Node := StoryNode 
		text: 'It’s a woman. It couldn’t be anything but. She must have double F cups and her lips are trapped in a cocksucking pout. Her breasts are loveably huge and her hips sway with the confidence that only befit a woman with an ass that could end wars. Deep purple eyes peer out from a frame of obsidian skin, topped with braided white hair.

“You’d think they’d be smart enough to avoid abduction zones, instead of be drawn to them like flies. Why did you look for us?”

She steps closer and every alarm in your body ratchets up another level. She smiles casually and throws her arms up in to the air as though conducting an orchestra. The Beast by your side is dispersed like dust on the wind and your alarm turns to full blown panic. Without your UI you’re all but trapped on this server.

It’s almost unheard of by this point, but before you can form a coherent sentence her hands are threaded through your hair, and you’re pulled in close to her. She kisses you hard, tongue wrestling with yours as she explores every taste your mouth has to offer.

She pulls back, and when you gasp for air you didn’t know you needed, she’s licking her lips. “Much better. It’s just you, and me”. She pushes you to the ground and drops to all fours, crawling towards you. She grips at your clothing and pulls her hands apart. Instead of removing it, you’re rendered immediately naked.

You feel the heat in you begin to flow immediately to your nethers, pussy growing soaked as you feel dreadlocks tickle their way up your thighs. The woman looks up at you over the crest of your tits, grinning wickedly. Then she blows you a kiss as her hand takes you, penetrating you hard, her thumb grinding a circle around your clit that fills your mind with sparks.

What must only have been a moment feels like forever as you soak yourself, coming hard on her hand at such a small amount of movement. The woman wipes her hand off on your thigh, standing up and licking off whatever seems to remain.

“You’re going to have to look in to some real protection if you want to go hunting for the big players. But sadly our time here is up. Good luck on the other side, we may meet again soon”.

You try to speak, but it feels like your tongue has been plastered to the roof of your mouth. You feel existence crunch up on itself as you’re booted viciously out of the net. You’re sprawled out on the floor of meatspace like a discarded doll with soaked panties, too nauseated to move.

You can barely hear the door to your home being kicked open as your consciousness starts to wink out. Two suited figures step on either side of you and pick you up by arms and legs. One of them quietly apologises before the blackness takes you.'.
	theEndNode := StoryNode
		text:
			'Thanks for taking part in version 0.1, coming soon will be the release of a real RPG UI. And more story, and options, with maps and towns to explore, and people to see, places to be, monsters to fight, and people and monsters to fuck.'.	
				
	map
		addStoryNode: introductionNode;
		addStoryNode: genderMaleNode;
		addStoryNode: genderFemaleNode;
		addStoryNode: maleScene1Node;
		addStoryNode: femaleScene1Node;
		addStoryNode: maleScene2Node;
		addStoryNode: femaleScene2Node;
		addStoryNode: maleScene3Node;
		addStoryNode: femaleScene3Node;
		addStoryNode: maleScene4Node;
		addStoryNode: femaleScene4Node;
		addStoryNode: theEndNode;
		startStoryOn: introductionNode.	
			
	map fromNode: introductionNode youCan: 'Male' andGoTo: genderMaleNode.
	map fromNode: introductionNode youCan: 'Female' andGoTo: genderFemaleNode.
	map fromNode: genderMaleNode youCan: 'Toned' andGoTo: maleScene1Node.
	map fromNode: genderMaleNode youCan: 'ComingSoon' andGoTo: maleScene1Node.
	map fromNode: genderFemaleNode youCan: 'Curvy' andGoTo: femaleScene1Node.
	map fromNode: genderFemaleNode youCan: 'ComingSoon' andGoTo: femaleScene1Node.
	map fromNode: maleScene1Node youCan: 'Dog' andGoTo: maleScene2Node.
	map fromNode: maleScene1Node youCan: 'ComingSoon' andGoTo: maleScene2Node.
	map fromNode: femaleScene1Node youCan: 'Dog' andGoTo: femaleScene2Node.
	map fromNode: femaleScene1Node youCan: 'ComingSoon' andGoTo: femaleScene2Node.
	map fromNode: maleScene2Node youCan: 'Guy' andGoTo: maleScene3Node.
	map fromNode: femaleScene2Node youCan: 'Guy' andGoTo: femaleScene3Node.
	map fromNode: maleScene2Node youCan: 'Girl' andGoTo: maleScene4Node.
	map fromNode: femaleScene2Node youCan: 'Girl' andGoTo: femaleScene4Node.
	map fromNode: maleScene3Node youCan: 'ComingSoon' andGoTo: theEndNode.
	map fromNode: femaleScene3Node youCan: 'ComingSoon' andGoTo: theEndNode.
	map fromNode: maleScene4Node youCan: 'ComingSoon' andGoTo: theEndNode.
	map fromNode: femaleScene4Node youCan: 'ComingSoon' andGoTo: theEndNode.
	^ map.! !

!StoryMap class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 06:42'!
example
	| mapa nodoComienzo nodoFinal |
	
	mapa := StoryMap new.
	nodoComienzo := StoryNode text: 'Welcome to the game. It''s super hot. Wear mittens!!'.
	nodoFinal := StoryNode
		text: 'You''ve won the game. You should be proud. We hope you enjoyed the lack of any erotic content.'.
	mapa
		addStoryNode: nodoComienzo;
		addStoryNode: nodoFinal;
		startStoryOn: nodoComienzo.
	mapa fromNode: nodoComienzo youCan: 'Win!!' andGoTo: nodoFinal.
	^ mapa.! !

!StoryMap methodsFor: 'public' stamp: 'FedericoFigueredo 6/1/2015 07:44'!
addStoryNode: aStoryNode 
	self nodes add: aStoryNode.! !

!StoryMap methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:04'!
beginning
	^ beginning.! !

!StoryMap methodsFor: 'public' stamp: 'FedericoFigueredo 6/3/2015 07:59'!
fromNode: originNode youCan: aString andGoTo: destinationNode 
	self nodes addIfNotPresent: originNode; addIfNotPresent: destinationNode.
	self transitions add: (StoryTransition origin: originNode destination: destinationNode actionDescription: aString).! !

!StoryMap methodsFor: 'accessing' stamp: 'FedericoFigueredo 6/1/2015 08:08'!
initialize
	nodes := OrderedCollection new.
	transitions := OrderedCollection new.! !

!StoryMap methodsFor: 'accessing' stamp: 'FedericoFigueredo 6/1/2015 07:49'!
nodes
	^ nodes.! !

!StoryMap methodsFor: 'public' stamp: 'SergioFedi 8/31/2015 10:06'!
nodesSize

	^self nodes size.! !

!StoryMap methodsFor: 'public' stamp: 'FedericoFigueredo 6/1/2015 07:59'!
startStoryOn: aStoryNode 
	self nodes addIfNotPresent: aStoryNode.
	beginning := aStoryNode.! !

!StoryMap methodsFor: 'accessing' stamp: 'FedericoFigueredo 6/1/2015 08:08'!
transitions
	^ transitions.! !

!StoryMap methodsFor: 'public' stamp: 'FedericoFigueredo 6/3/2015 07:24'!
transitionsFrom: aStoryNode 
	^ self transitions select: [ :each | each origin = aStoryNode ].! !

Object subclass: #StoryNode
	instanceVariableNames: 'text paragraphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!StoryNode commentStamp: 'SergioFedi 6/5/2015 20:41' prior: 0!
I model a specific point in the story space.
For example, the beginning of a story is an instance of me.
So are the different endings.!

!StoryNode class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/1/2015 07:38'!
text: aString 
	^ self new text: aString.! !

!StoryNode methodsFor: 'accessors' stamp: 'SergioFedi 6/18/2015 06:28'!
paragraphs

	^paragraphs.! !

!StoryNode methodsFor: 'accessors' stamp: 'SergioFedi 6/18/2015 06:41'!
paragraphs: aCollection 
	paragraphs := aCollection! !

!StoryNode methodsFor: 'accessors' stamp: 'SergioFedi 6/6/2015 00:17'!
text
	^ text! !

!StoryNode methodsFor: 'setter' stamp: 'SergioFedi 6/18/2015 06:52'!
text: aString 
	text := aString.
	self paragraphs: (aString 
		findBetweenSubStrs: (Array with: Character cr with: Character cr) asArray).! !

Object subclass: #StoryTransition
	instanceVariableNames: 'origin destination actionDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!StoryTransition commentStamp: 'SergioFedi 6/5/2015 20:42' prior: 0!
I model a change from one StoryNode to another.
This includes the origin, destination and what makes the change.!

!StoryTransition class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/3/2015 08:03'!
origin: aStoryNode destination: aStoryNode2 actionDescription: aString 
	^ self new
		origin: aStoryNode; 
		destination: aStoryNode2; 
		actionDescription: aString.		! !

!StoryTransition methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 08:02'!
actionDescription
	^ actionDescription.! !

!StoryTransition methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 08:03'!
actionDescription: aString 
	actionDescription := aString.! !

!StoryTransition methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:25'!
destination
	^ destination.! !

!StoryTransition methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/2/2015 06:29'!
destination: aStoryNode 
	destination := aStoryNode.! !

!StoryTransition methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:24'!
origin
	^ origin.! !

!StoryTransition methodsFor: 'setter' stamp: 'FedericoFigueredo 6/2/2015 06:27'!
origin: aStoryNode 
	origin := aStoryNode.! !
